  %   animations_graphs
%   chris briglio

function animations_graphs()

    %clears command windows and figures
    clc;
    clear;
    close all;

    global paused;
    global t;
    global last;
    global time_changed;
    global firstchange;
    global links;
    global linkschanged;
    global pausetime;
    global exitflag;
    global marker;
    marker = 0;
    exitflag = false;
    pausetime = 0;
    linkschanged = false;
    links = true;
    paused = false;
    t = 0;
    last = 0;
    time_changed = false;
    firstchange = true;

    %max = 999999;  "max" appears to be unused. Old code, perhaps?
    %max = 1000000;

    %opens the movement file and reads in the first line
    fprintf('Please enter the path to the output files\n');
    filename = input('>> ', 's');

    %reads the total_time from the bottom of the input file
    %this is how long it takes until the network is static
    fid = fopen(filename);
    a = 'test';
    
    while feof(fid) == 0 
        a = fgets(fid);    
    end  %end while
    
    total_time = str2double(a);
    fclose(fid);

    %prompts the user to enter the deired animation runtime
    run_time = -1;
    
    while run_time <= 1 || run_time > total_time
        
        fprintf('The network will not be static until %i seconds\n', total_time);
        run_time = str2double(input('Please enter desired animation runtime:\n', 's'));

        if run_time <= 1
            fprintf('Please enter a runtime greater than 1. Try again:\n\n');
        elseif run_time > total_time
            fprintf('Please enter a runtime less than %f. Try Again:\n\n', total_time);
        elseif run_time > 1
            run_time = floor(run_time);
        else
            run_time = total_time;
        end 
        
    end  %end while
    
    fprintf('\n');

    %this code is used to automatically generate the input filenames based off
    %of the input name supplied by the user

    fileindex = strfind(filename,'output');
    filenamemask = filename(1:fileindex);
    filename2 = strcat(filenamemask,'utput\average_neighbours.txt');
    filename3 = strcat(filenamemask,'utput\most_neighbours.txt');
    filename4 = strcat(filenamemask,'utput\average_path_length.txt');
    filename5 = strcat(filenamemask,'utput\diameter.txt');
    filename6 = strcat(filenamemask,'utput\components.txt');
    filename7 = strcat(filenamemask,'utput\links.txt');
    filename8 = strcat(filenamemask,'utput\run_time.txt');
    filename9 = strcat(filenamemask,'utput\coverage.txt');
    filename10 = strcat(filenamemask,'utput\average_clustering.txt');
    filename11 = strcat(filenamemask,'utput\average_instability.txt');

    fid = fopen(filename);
    fid2 = fopen(filename2);
    fid3 = fopen(filename3);
    fid4 = fopen(filename4);
    fid5 = fopen(filename5);
    fid6 = fopen(filename6);
    fid7 = fopen(filename7);
    fid8 = fopen(filename8);
    fid9 = fopen(filename9);
    fid10 = fopen(filename10);
    fid11 = fopen(filename11);

    read_line = fgets(fid8);

    stats_run_time = str2double(read_line);

    read_line = fgets(fid); %Use extra fgets() to skip to second line of file
    read_line = fgets(fid);

    %reads in the number of nodes, the refresh inteval, the transmission range,
    %axis information and whether or not this is in troubleshoot mode
    num_nodes = sscanf(read_line, '%f %*f %*f %*f %*f %*f');
    refresh_interval = sscanf(read_line, '%*f %f %*f %*f %*f %*f');
    transmission_range = sscanf(read_line, '%*f %*f %f %*f %*f %*f');
    axis_x = sscanf(read_line, '%*f %*f %*f %f %*f %*f');
    axis_y = sscanf(read_line, '%*f %*f %*f %*f %f %*f');
    troubleshoot = sscanf(read_line, '%*f %*f %*f %*f %*f %f');
    
    %arrays used for each statistic
    refresh = stats_run_time/refresh_interval;
    time2 = zeros(1,refresh);
    average_neighbours = zeros(1,refresh);
    number_of_most_neighbours = zeros(1,refresh);
    average_path_length_hops = zeros(1,refresh);
    average_path_length_metres = zeros(1,refresh);
    diameter_hops = zeros(1,refresh);
    diameter_metres = zeros(1,refresh);
    components = zeros(1,refresh);
    links_added = zeros(1,refresh);
    links_broken = zeros(1,refresh);
    coverage = zeros(1,refresh);
    clustering = zeros(1,refresh);
    instability = zeros(1,refresh);

    %reads in statistic information from file

    for i = 1: refresh

        read_line = fgets(fid2);
        time2(1,i)= sscanf(read_line, '%f %*f');
        average_neighbours(1,i) = sscanf(read_line, '%*f %f');

        read_line = fgets(fid3);
        bracket_index = strfind(read_line, '(');
        a = read_line(bracket_index:bracket_index+2);
        number_of_most_neighbours(1,i) = str2double(read_line(bracket_index+1));  

        %troubleshoot mode does not read in stats measure in hops
        if troubleshoot == 1
            
            read_line = fgets(fid4);
            time2(1,i)= sscanf(read_line, '%f %*f');
            average_path_length_metres(1,i) = sscanf(read_line, '%*f %f');

            read_line = fgets(fid5);
            time2(1,i)= sscanf(read_line, '%f %*f');
            diameter_metres(1,i) = sscanf(read_line, '%*f %f');
            
        else
            
            read_line = fgets(fid4);
            time2(1,i)= sscanf(read_line, '%f %*f %*f');
            average_path_length_hops(1,i) = sscanf(read_line, '%*f %f %*f');
            average_path_length_metres(1,i) = sscanf(read_line, '%*f  %*f %f');

            read_line = fgets(fid5);
            time2(1,i)= sscanf(read_line, '%f %*f %*f');
            diameter_hops(1,i) = sscanf(read_line, '%*f %f %*f');
            diameter_metres(1,i) = sscanf(read_line, '%*f %*f %f');

        end %end if

        read_line = fgets(fid6);
        time2(1,i)= sscanf(read_line, '%f %*f');
        components(1,i) = sscanf(read_line, '%*f %f');


        read_line = fgets(fid7);
        time2(1,i)= sscanf(read_line, '%f %*f %*f');
        links_added(1,i) = sscanf(read_line, '%*f %f %*f');
        links_broken(1,i) = sscanf(read_line, '%*f %*f %f');
        
        read_line = fgets(fid9);
        time2(1,i)= sscanf(read_line, '%f %*f');
        coverage(1,i) = sscanf(read_line, '%*f %f');
        
        read_line = fgets(fid10);
        time2(1,i)= sscanf(read_line, '%f %*f');
        clustering(1,i) = sscanf(read_line, '%*f %f');
        
        if i > 8
            read_line = fgets(fid11);
            time2(1,i)= sscanf(read_line, '%*f %f %*f');
            instability(1,i) = sscanf(read_line, '%*f %*f %f');
        end


        time2(1,i) = (i-1)*refresh_interval;
        
    end %end for

    %plots all statistics
    figure('name', 'Average # of Node Neighbours vs. Time');
    plot(time2(1:refresh), average_neighbours(1:refresh));
    title('Average # of Node Neighbours vs. Time');
    xlabel('Elapsed Time');
    ylabel('Average # of Neighbours');


    figure('name', '# of Most Node Neighbours vs. Time');
    plot(time2(1:refresh), number_of_most_neighbours(1:refresh));
    title('# of Most Node Neighbours vs. Time');
    xlabel('Elapsed Time');
    ylabel('# of Most Node Neighbours');

    if troubleshoot == 0

        figure('name', 'Average Path Length(Hops) vs. Time');
        plot(time2(1:refresh), average_path_length_hops(1:refresh));
        title('Average Path Length(Hops) vs. Time');
        xlabel('Elapsed Time');
        ylabel('Average Path Length(Hops)');
        
    end %end if

    figure('name', 'Average Path Length(m) vs. Time');
    plot(time2(1:refresh), average_path_length_metres(1:refresh));
    title('Average Path Length(m) vs. Time');
    xlabel('Elapsed Time');
    ylabel('Average Path Length(m)');

    if troubleshoot == 0
        
        figure('name', 'Diameter(Hops) vs. Time');
        plot(time2(1:refresh), diameter_hops(1:refresh));
        title('Diameter(Hops) vs. Time');
        xlabel('Elapsed Time');
        ylabel('Diameter(Hops)');
        
    end %end if

    figure('name', 'Diameter(m) vs. Time')
    plot(time2(1:refresh), diameter_metres(1:refresh));
    title('Diameter(m) vs. Time');
    xlabel('Elapsed Time');
    ylabel('Diameter(m)');

    figure('name', '# of Network Components vs. Time');
    plot(time2(1:refresh), components(1:refresh));
    title('# of Network Components vs. Time');
    xlabel('Elapsed Time');
    ylabel('# of Network Components');
    
    figure('name', '% Coverage of Area vs. Time');
    plot(time2(1:refresh), coverage(1:refresh));
    title('% Coverage of Area vs. Time');
    xlabel('Elapsed Time');
    ylabel('% Coverage');
    
    figure('name', 'Network Clustering vs. Time');
    plot(time2(1:refresh), clustering(1:refresh));
    title('Network Clustering vs. Time');
    xlabel('Elapsed Time');
    ylabel('Network Clustering');
    
    figure('name', 'Neighbourhood Instability vs. Time');
    plot(time2(9:refresh), instability(9:refresh));
    title('Neighbourhood Instability vs. Time');
    xlabel('Elapsed Time');
    ylabel('Neighbourhood Instability');


    if refresh_interval == 1
        
        links_added(1,1) = 0;
        figure('name', '# of Links Created vs. Time');
        plot(time2(1:refresh), links_added(1:refresh));
        title('# of Links Created vs. Time');
        xlabel('Elapsed Time');
        ylabel('# of Links Created');

        figure('name', '# of Links Broken vs. Time');
        plot(time2(1:refresh), links_broken(1:refresh));
        title('# of Links Broken vs. Time');
        xlabel('Elapsed Time');
        ylabel('# of Links Broken');
        
    end %end if

    
    % close files
    fclose(fid2);
    fclose(fid3);
    fclose(fid4);
    fclose(fid5);
    fclose(fid6);
    fclose(fid7);
    fclose(fid8);
    fclose(fid9);
    fclose(fid10);
    fclose(fid11);
    
    
    %name animation
    figure('name', 'Animation');
    
    %rounds the axis to the nearest 100
    axis_x = axis_x /100;
    axis_x = ceil(axis_x);
    axis_x = axis_x * 100;
    axis_y = axis_y /100;
    axis_y = ceil(axis_y);
    axis_y = axis_y * 100;

    %stores the index location where the node has stopped moving
    reached_destination = zeros(num_nodes, 1);

    %stores the current coordinates of each node
    coordinates = zeros(num_nodes, 1);
    
    if num_nodes*run_time > 1000000
        fprintf('WARNING: ARRAY LENGTH FOR NODES EXCEEDS 1 MILLION, MAY CAUSE CRASH\nPress any key to continue...');
        pause();
    end

    %location reads in each line of movement from fid
    location = zeros(num_nodes*run_time, 4);
    [location_height, location_width] = size(location);
    location_height %Debugging
    location_width
    read_line = fgets(fid);
    

    %total_time stores how long the animation runs for 
    total_time = 0;
    
    % transmission_range = 250;
    edge_array = zeros(num_nodes, num_nodes);


    %change so it only reads untill node has reached run time
    for i = 1: location_height

        %reads each line and checks if it has node or #
        read_line = fgets(fid);
        node_check = isempty(strfind(read_line, 'destination'));
        hashtag_check = isempty(strfind(read_line, '#'));

        %breaks if eof reached
        if read_line == -1

            break;

        elseif node_check == 1 && hashtag_check == 1
            
            % reads in the location of the node
            %disp(read_line) %Debug: Display the related line
            location(i,1) = sscanf(read_line, '%f %*f %*f %*f');
            node = location(i,1);
            location(i,2) = sscanf(read_line, '%*f %f %*f %*f');
            time = location(i,2);
            location(i,3) = sscanf(read_line, '%*f %*f %f %*f');
            location(i,4) = sscanf(read_line, '%*f %*f %*f %f');
            
            if location(i,2) == run_time                   %if time equals event time skip all other destination and go to next node
                reached_destination(node+1, 1) = time;
                node_check = 1; 
                while node_check == 1
                    read_line = fgets(fid);
                    node_check = isempty(strfind(read_line, 'destination'));
                end
                read_line = fgets(fid);
            end

        elseif node_check == 0 && hashtag_check == 1
            
            % if the line contains "Node", the line is skipped
            read_line = fgets(fid);
            node_check = 1;       
            reached_destination(node+1, 1) = time;

        else 

            % if a hashtag is found, the line is skipped and the total time is read
            % the loop is then ended
            read_line = fgets(fid);
            total_time = sscanf(read_line, '%f');
            break;

        end  % end if
        
        %fprintf('%i %i %i %i %i %i\n',i,location_height,location(i,1),location(i,2),location(i,3),location(i,4));

    end  %end for

    fclose(fid);

    % deletes the unused entries of the location matrix
    location(all(location==0,2),:)=[];

    % resets the start index
    start_time_index = 0;

    % sets the axis to the correct value
    axis([0 axis_x 0 axis_y]);

    %plots the first node
    hold on   
        plot(location(1,3), location(1,4), 'Marker', '+', 'MarkerSize', 20);
        % fprintf('%i %f %f\n', 0, location(1, 3), location(1, 4));
    hold off 

    %determines and plots each node at time = 0
    for k = 2: num_nodes

        hold on 
        
            reached_destination(k, 1);

            start_time_index = start_time_index + reached_destination(k-1, 1);

            plot(location(start_time_index, 3), location(start_time_index, 4), 'Marker', '+', 'MarkerSize', 20);
            
        hold off 
        
    end %end for

    % starts the timer (unused)
    tic;
    %ticID = tic ;

    % resets variables used for timer (unused)
    %elapsedTime = 0;
    last_tock = 0;
    seconds_passed = 0;
    %i = 1;

    % an array used to store where the index is for each node
    index = zeros(num_nodes, 1);
    index(1,1) = 1;

    [location_height, location_width] = size(location);

    % stores whether or not the array has been reached by the index #
    end_of_array = zeros(num_nodes, 1);

    %resets variables
    t = 0;
    total_added_links = 0;
    total_broken_links = 0;
    added_links = 0;
    broken_links = 0;

    %create variable to control if paused or not
    %paused = false; 
    
     % create all the buttons
    pausebutton = uicontrol('String','Pause','pos',[190 5 40 20]);
    set(pausebutton,'Callback',{@pausebutton_callback});
    playbutton = uicontrol('String','Play','pos',[235 5 40 20]);
    set(playbutton,'Callback',{@playbutton_callback});
    linkbutton = uicontrol('String','Show Links','pos',[10 5 75 20]);
    set(linkbutton,'Callback',{@linkbutton_callback});
    exitbutton = uicontrol('String','EXIT','pos',[10 470 30 20]);
    set(exitbutton,'Callback',{@exitbutton_callback});
    timefield = uicontrol('Style','edit','String','0','pos',[275 5 75 20]);
    set(timefield,'Callback',{@timefield_callback});
    markertype = uicontrol('String','Marker','pos',[5 65 50 20]);
    set(markertype,'Callback',{@markertype_callback});
    statename = uicontrol('Style','text','String','Status: Running','pos',[87 5 100 20]);
    slidetime = uicontrol('Style','slider','pos',[350 5 200 20],'Max',run_time,'Sliderstep',[1/run_time 10/run_time]);
    pausetimeslider = uicontrol('Style','slider','pos',[1 45 60 15],'Max',1);
    pausetimename = uicontrol('Style','text','String','Delay: 0','pos',[5 30 75 15],'HorizontalAlignment','left');
    set(slidetime,'Callback',{@slidetime_callback});
    set(pausetimeslider,'Callback',{@pausetime_callback});


    while t < run_time+1   
        
        if exitflag == true
            break;
        end
        
        title(t);

        set(pausetimename,'String',['Delay: ',num2str(get(pausetimeslider,'Value'))]);
        set(timefield,'String',num2str(t));
        
        if t > 0 && t < run_time
            
             if paused == false
                set(slidetime,'Visible','off');
                set(timefield,'Visible','off');
                set(statename,'String','Status: Running');
                set(playbutton,'Visible','off');
                set(pausebutton,'Visible','on');
                figure(13);
            else
                set(slidetime,'Visible','on');
                set(timefield,'Visible','on');
                set(statename,'String','Status: Paused');
                set(playbutton,'Visible','on');
                set(pausebutton,'Visible','off');
             end
            set(linkbutton,'Visible','on');
            set(markertype,'Visible','on');
            
        elseif t == 0
            
             if paused == false
                set(slidetime,'Visible','off');
                set(timefield,'Visible','off');
                set(statename,'String','Status: Running');
                figure(13);
            else
                set(slidetime,'Visible','off');
                set(timefield,'Visible','off');
                set(statename,'String','Status: Paused');
            end
            set(linkbutton,'Visible','off');
            set(markertype,'Visible','off');
            set(playbutton,'Visible','on');
            set(pausebutton,'Visible','off');
            
        elseif t >= run_time + 1
            
            paused = true;
            set(slidetime,'Visible','on');
            set(timefield,'Visible','on');
            set(statename,'String','Status: Paused');
            set(playbutton,'Visible','off');
            set(pausebutton,'Visible','off');
            
        end


        if time_changed == true

            % clears the figure
            cla;
            hold on
            
            time_changed = false;
            %fprintf('\nt = %i\n',t);

            if t > 1

                %elapsedTime = t - 1; is unused
                last_tock = t - 1;
                seconds_passed = t - 1;

                for i = 1: num_nodes
                    index(i,1) = t - 1;
                    for k = 1: i-1
                         index(i,1) = index(i,1) + reached_destination(k);
                    end
                    if i > 1
                        index(i,1) = index(i,1) - 1;
                    end
                    if index(i,1) > location_height
                        end_of_array(i,1) = 1;
                        index(i,1) = reached_destination(i,1);
                    end
                    
                    coordinates(i,1) = location(index(i,1),3);
                    coordinates(i,2) = location(index(i,1),4);
                    
                    if marker == 0
                        plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'o', 'MarkerSize', 20, 'markerfa', 'w');
                        text(location(index(i,1),3), location(index(i,1),4), int2str(i-1), 'Color', 'r');
                   elseif marker == 1
                        plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 5, 'markerfa', 'w');
                   else
                        plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 20, 'markerfa', 'w');
                   end    
                    
                    %fprintf('index = %i',index(i,1));
                    %fprintf('  i = %i\n',i);
                    
                    
                    
                end
                
                % determines if the nodes has reached its destination
                for j = 1: num_nodes - 1 

                    if (index(j,1) <= location_height)

                        for k = j+1: num_nodes

                            if (index(k,1) > location_height)
                                index(k,1) = reached_destination(k,1);
                            end 

                            distance = sqrt((location(index(k,1),3) - location(index(j,1),3))^2 + (location(index(k,1),4) - location(index(j,1),4))^2);

                            if distance <= transmission_range

                                if edge_array(j,k) == 0      
                                    edge_array(j,k) = 1;
                                    edge_array(k,j) = 1;
                                    added_links = added_links + 1;
                                end
                            else 

                                if edge_array(j,k) == 1
                                    edge_array(j,k) = 0;
                                    edge_array(k,j) = 0;
                                    broken_links = broken_links + 1;    
                                end

                            end  %end if

                        end %end for

                    else

                        index(j,1) = reached_destination(j,1);

                           for k = j+1: num_nodes

                               distance = sqrt((location(index(k,1),3) - location(index(j,1),3))^2 + (location(index(k,1),4) - location(index(j,1),4))^2);

                               if distance <= transmission_range 

                                   if edge_array(j,k) == 0
                                       edge_array(j,k) = 1;
                                       edge_array(k,j) = 1;
                                       added_links = added_links + 1;
                                   end

                               else

                                   if edge_array(j,k) == 1
                                       edge_array(j,k) = 0;
                                       edge_array(k,j) = 0;
                                       broken_links = broken_links + 1;    
                                   end 

                               end  %end if

                           end  %end for

                           %fprintf('\n');

                    end  %end for 

                    hold on

                    if links == true
                        %gplot plots the lines between nodes
                        %edge_array is an Adjacency Array 
                        %(MATLAB's website has a good page on this)
                        gplot(edge_array, coordinates,'-k.');
                    end

                    title(t);
                    %next_node = 0;     

                end  %end for

            elseif t == 0

                %elapsedTime = 0;
                last_tock = 0;
                seconds_passed = 0;
                index(1,1) = 1;
                for i = 2: num_nodes
                     index(i,1) = 0;
                end

            elseif t == 1
                
                for i = 1: num_nodes
                    
                    %elapsedTime = 1;
                    last_tock = 1;
                    seconds_passed = 1;
                    index(i,1) = 0;
                    for k = 1: i - 1
                        index(i,1) = index(i,1) + reached_destination(k);
                    end
                    index(1,1) = 1;

                    coordinates(i,1) = location(index(i,1),3);
                    coordinates(i,2) = location(index(i,1),4);

                    if marker == 0
                        plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'o', 'MarkerSize', 20, 'markerfa', 'w');
                        text(location(index(i,1),3), location(index(i,1),4), int2str(i-1), 'Color', 'r');
                   elseif marker == 1
                        plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 5, 'markerfa', 'w');
                   else
                        plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 20, 'markerfa', 'w');
                   end  

                end
                
                % determines if the nodes has reached its destination
                for j = 1: num_nodes - 1 

                    if (index(j,1) <= location_height)

                        for k = j+1: num_nodes

                            if (index(k,1) > location_height)
                                index(k,1) = reached_destination(k,1);
                            end 

                            distance = sqrt((location(index(k,1),3) - location(index(j,1),3))^2 + (location(index(k,1),4) - location(index(j,1),4))^2);

                            if distance <= transmission_range

                                if edge_array(j,k) == 0      
                                    edge_array(j,k) = 1;
                                    edge_array(k,j) = 1;
                                    added_links = added_links + 1;
                                end
                            else 

                                if edge_array(j,k) == 1
                                    edge_array(j,k) = 0;
                                    edge_array(k,j) = 0;
                                    broken_links = broken_links + 1;    
                                end

                            end  %end if

                        end %end for

                    else

                        index(j,1) = reached_destination(j,1);

                           for k = j+1: num_nodes

                               distance = sqrt((location(index(k,1),3) - location(index(j,1),3))^2 + (location(index(k,1),4) - location(index(j,1),4))^2);

                               if distance <= transmission_range 

                                   if edge_array(j,k) == 0
                                       edge_array(j,k) = 1;
                                       edge_array(k,j) = 1;
                                       added_links = added_links + 1;
                                   end

                               else

                                   if edge_array(j,k) == 1
                                       edge_array(j,k) = 0;
                                       edge_array(k,j) = 0;
                                       broken_links = broken_links + 1;    
                                   end 

                               end  %end if

                           end  %end for

                           %fprintf('\n');

                    end  %end for 

                    hold on

                    if links == true
                        %gplot plots the lines between nodes
                        %edge_array is an Adjacency Array 
                        %(MATLAB's website has a good page on this)
                        gplot(edge_array, coordinates,'-k.');
                    end

                    title(t);
                    %next_node = 0;     

                end  %end for
                
            end
            
            
            %edge_array;
            
            drawnow

            hold off

        end % end if
        
        
         if linkschanged == true
            
            linkschanged = false;
            
            % clears the figure
            cla;
            hold on
            
            for i = 1: num_nodes
                coordinates(i,1) = location(index(i,1),3);
                coordinates(i,2) = location(index(i,1),4);
                if marker == 0
                    plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'o', 'MarkerSize', 20, 'markerfa', 'w');
                    text(location(index(i,1),3), location(index(i,1),4), int2str(i-1), 'Color', 'r');
               elseif marker == 1
                    plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 5, 'markerfa', 'w');
               else
                    plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 20, 'markerfa', 'w');
               end  
            end
            
            % determines if the nodes has reached its destination
            for j = 1: num_nodes - 1 

                if (index(j,1) <= location_height)

                    for k = j+1: num_nodes

                        if (index(k,1) > location_height)
                            index(k,1) = reached_destination(k,1);
                        end 

                        distance = sqrt((location(index(k,1),3) - location(index(j,1),3))^2 + (location(index(k,1),4) - location(index(j,1),4))^2);

                        if distance <= transmission_range

                            if edge_array(j,k) == 0      
                                edge_array(j,k) = 1;
                                edge_array(k,j) = 1;
                                added_links = added_links + 1;
                            end
                        else 

                            if edge_array(j,k) == 1
                                edge_array(j,k) = 0;
                                edge_array(k,j) = 0;
                                broken_links = broken_links + 1;    
                            end

                        end  %end if

                    end %end for

                else

                    index(j,1) = reached_destination(j,1);

                       for k = j+1: num_nodes

                           distance = sqrt((location(index(k,1),3) - location(index(j,1),3))^2 + (location(index(k,1),4) - location(index(j,1),4))^2);

                           if distance <= transmission_range 

                               if edge_array(j,k) == 0
                                   edge_array(j,k) = 1;
                                   edge_array(k,j) = 1;
                                   added_links = added_links + 1;
                               end

                           else

                               if edge_array(j,k) == 1
                                   edge_array(j,k) = 0;
                                   edge_array(k,j) = 0;
                                   broken_links = broken_links + 1;    
                               end 

                           end  %end if

                       end  %end for

                       %fprintf('\n');

                end  %end for 

                hold on

                if links == true
                    %gplot plots the lines between nodes
                    %edge_array is an Adjacency Array 
                    %(MATLAB's website has a good page on this)
                    gplot(edge_array, coordinates,'-k.');
                end

                title(t);
                %next_node = 0;     

            end  %end for

            %edge_array;
            drawnow
            hold off
            
        end

        if paused == false


            %fprintf('t = %i\n',t);
            %fprintf('paused = %i\n',paused);
            %fprintf('time_changed = %i\n',time_changed);
            %fprintf('slidetime = %i\n',get(slidetime,'Value'));
            %fprintf('elapsedTime = %i\n',elapsedTime);
            %fprintf('seconds_passed = %i\n',seconds_passed);
            %fprintf('last_tock = %i\n\n',last_tock);

            set(slidetime,'Value',t); %set slider to current time

            firstchange = true;

            %stores the current time
            elapsedTime = t;
            %elapsedTime = toc(ticID);

            %executes if the time unit has passed (ex. 1 sec)
            if elapsedTime - last_tock >= 1

                seconds_passed = seconds_passed + 1;

                % disp(seconds_passed);
                last_tock = elapsedTime;
                % stores the number of changed links per second        
                total_added_links = total_added_links + added_links;
                total_broken_links = total_broken_links + broken_links;
                added_links = 0;
                broken_links = 0;

                % clears the figure
                cla;
                hold on         

                %increases the index for each node
                %if statements are used to ensure that index does not go outside
                %the bounds of the location array
                for i = 1: num_nodes

%                        fprintf('index = %i',index(i,1));
%                        fprintf('  i = %i',i);
%                       fprintf('  location_height = %i',location_height);
%                       fprintf('  end_of_array = %i\n',end_of_array(i));

                    if index(i,1) > location_height || end_of_array(i) == 1

                        index(i,1) = 0;

                        for k = 1: i
                            index(i,1) = index(i,1) + reached_destination(k);
                        end

                        index(i,1) = index(i,1) - 1;
                        end_of_array(i,1) = 1;

                        coordinates(i,1) = location(index(i,1),3);
                        coordinates(i,2) = location(index(i,1),4);

                        if marker == 0
                            plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'o', 'MarkerSize', 20, 'markerfa', 'w');
                            text(location(index(i,1),3), location(index(i,1),4), int2str(i-1), 'Color', 'r');
                       elseif marker == 1
                            plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 5, 'markerfa', 'w');
                       else
                            plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 20, 'markerfa', 'w');
                       end  

                    elseif index(i,1) <= location_height

                        if seconds_passed <= 1

                            for k = 1: i - 1
                                index(i,1) = index(i,1) + reached_destination(k);
                            end

                        elseif location(index(i,1), 1) == i - 1

                            index(i,1) = index(i,1) + 1;

                        end

                        if index(i,1) > location_height

                            end_of_array(i,1) = 1;
                            index(i,1) = reached_destination(i,1);

                        elseif location(index(i,1), 1) ~= i - 1

                            index(i,1) = 0;

                            for k = 1: i
                                index(i,1) = index(i,1) + reached_destination(k);
                            end

                            index(i,1) = index(i,1) - 1;
                            coordinates(i,1) = location(index(i,1),3);
                            coordinates(i,2) = location(index(i,1),4);

                           if marker == 0
                                plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'o', 'MarkerSize', 20, 'markerfa', 'w');
                                text(location(index(i,1),3), location(index(i,1),4), int2str(i-1), 'Color', 'r');
                           elseif marker == 1
                                plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 5, 'markerfa', 'w');
                           else
                                plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 20, 'markerfa', 'w');
                           end   

                        else 

                            coordinates(i,1) = location(index(i,1),3);
                            coordinates(i,2) = location(index(i,1),4);

                            if marker == 0
                                plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'o', 'MarkerSize', 20, 'markerfa', 'w');
                                text(location(index(i,1),3), location(index(i,1),4), int2str(i-1), 'Color', 'r');
                           elseif marker == 1
                                plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 5, 'markerfa', 'w');
                           else
                                plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 20, 'markerfa', 'w');
                           end  

                        end %end if 

                    else 

                        coordinates(i,1) = location(index(i,1),3);
                        coordinates(i,2) = location(index(i,1),4);

                        if marker == 0
                            plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'o', 'MarkerSize', 20, 'markerfa', 'w');
                            text(location(index(i,1),3), location(index(i,1),4), int2str(i-1), 'Color', 'r');
                       elseif marker == 1
                            plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 5, 'markerfa', 'w');
                       else
                            plot(location(index(i,1),3), location(index(i,1),4), 'Marker', 'x', 'MarkerSize', 20, 'markerfa', 'w');
                       end   

                    end %end if

                end %end for

                % determines if the nodes has reached its destination
                for j = 1: num_nodes - 1 

                    if (index(j,1) <= location_height)

                        for k = j+1: num_nodes

                            if (index(k,1) > location_height)
                                index(k,1) = reached_destination(k,1);
                            end 

                            distance = sqrt((location(index(k,1),3) - location(index(j,1),3))^2 + (location(index(k,1),4) - location(index(j,1),4))^2);

                            if distance <= transmission_range

                                if edge_array(j,k) == 0      
                                    edge_array(j,k) = 1;
                                    edge_array(k,j) = 1;
                                    added_links = added_links + 1;
                                end
                            else 

                                if edge_array(j,k) == 1
                                    edge_array(j,k) = 0;
                                    edge_array(k,j) = 0;
                                    broken_links = broken_links + 1;    
                                end

                            end  %end if

                        end %end for

                    else

                        index(j,1) = reached_destination(j,1);

                           for k = j+1: num_nodes

                               distance = sqrt((location(index(k,1),3) - location(index(j,1),3))^2 + (location(index(k,1),4) - location(index(j,1),4))^2);

                               if distance <= transmission_range 

                                   if edge_array(j,k) == 0
                                       edge_array(j,k) = 1;
                                       edge_array(k,j) = 1;
                                       added_links = added_links + 1;
                                   end

                               else

                                   if edge_array(j,k) == 1
                                       edge_array(j,k) = 0;
                                       edge_array(k,j) = 0;
                                       broken_links = broken_links + 1;    
                                   end 

                               end  %end if

                           end  %end for

                           %fprintf('\n');

                    end  %end for 

                    hold on

                    if links == true
                        %gplot plots the lines between nodes
                        %edge_array is an Adjacency Array 
                        %(MATLAB's website has a good page on this)
                        gplot(edge_array, coordinates,'-k.');
                    end
                    
                    title(t);
                    %next_node = 0;     

                end  %end for

                %edge_array;

                drawnow

                hold off 

             end %end if

              t = t + 1; 
              
              if pausetime ~= 0
                pause(pausetime);
              end

        else
            
            pause(0.1); %if paused put slight delay in loop to allow user to hit play button
            
        end %end if
        
        if t >= run_time+1
            paused = true;
            time_changed = true;
            t = 0; 
            title(t);
        end
        
        if exitflag == true
            break;
        end

    end  %end while
 
end   %end animations_graphs


function pausebutton_callback(~,~)

    global paused;
    paused = true;

end

function playbutton_callback(~,~)

    global paused;
    paused = false;

end

function linkbutton_callback(~,~)

    global links;
    global linkschanged;
    linkschanged = true;
    if links == true
        links = false;
    else
        links = true;
    end

end

function slidetime_callback(hObject,~)

    global paused;
    global t;
    global last;
    global time_changed;
    time_changed = true;
    last = t;
    t = round(get(hObject,'Value'));
    paused = true;

end

function pausetime_callback(hObject,~)

global pausetime;

pausetime = get(hObject,'Value');

end

function exitbutton_callback(~,~)
    global exitflag;
    exitflag = true;
end

function timefield_callback(hObject,~)

    global paused;
    global t;
    global last;
    global time_changed;

    Nd = sum(isstrprop(get(hObject,'String'),'digit'));
    Nc = length(get(hObject,'String'));
 
    dN = Nc - Nd;

    if (dN == 0)
        
        time_changed = true;
        last = t;
        t = round(str2num(get(hObject,'String')));
        if t < 0
            t = 0;
        end
        paused = true;

    else
        set(hObject,'String',num2str(t));
    end
    
end

function markertype_callback(~,~)

    global linkschanged;
    linkschanged = true;
    global marker;
    if marker == 0
        marker = 1;
    elseif marker == 1
        marker = 2;
    else
        marker = 0;
    end
    
end

