//		Statistics for Dynamic & Static Networks
//		Chris Briglio


#include "stdafx.h"


//------------------------------------------------------------------------------MAIN PROGRAM-----------------------------------------------------------------------------------------//

//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


using namespace std;


/*
	main:
		Program HUB. Serves as title screen and access point for
		all aspects of Statistics for Dynamic & Static Networks Program.
*/
int main()
{
    
 //------------------------------------------------------------------------------VARIABLES--------------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//
    
	bool title = true;

	string input = "";

 //------------------------------------------------------------------------------TITLE SCREEN-----------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


	do		//do-while loop for title screen
	{
		
		cout << "\n";
		cout << "\t***********************************************\n";
		cout << "\t*                                             *\n";
		cout << "\t*   Statistics for Dynamic & Static Networks  *\n";
		cout << "\t*                                             *\n";
		cout << "\t*                                             *\n";
		cout << "\t*                Options:                     *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           1. Location Generator             *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           2. Dynamic Statistics             *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           3. Static Statistics              *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           4. Statistics Summary             *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           5. Spreadsheet Creator            *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           6. View Statistics in MATLAB      *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           7. Full Statistical Run Through   *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           8. Exit                           *\n";
		cout << "\t*                                             *\n";
		cout << "\t***********************************************\n";
		cout << "\n\n";
          
		cout << "\t                >> "; getline(cin,input);
          
		boost::to_upper(input);
          

		if (input == "1")
		{
			system("CLS");
			LocationGenerator(false);
			system("CLS");
		}
		else if (input == "2")
		{
			system("CLS");
			DynamicStatistics("",0,false);
			system("CLS");
		}
		else if (input == "3")
		{
			system("CLS");
			StaticStatistics();
			system("CLS");
		}
		else if (input == "4")
		{
			system("CLS");
			do
			{
				
				cout << "\n";
				cout << "\t***********************************************\n";
				cout << "\t*                                             *\n";
				cout << "\t*   Statistics for Dynamic & Static Networks  *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                Options:                     *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           1. Static Statistics Summary      *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           2. Dynamic Statistics Summary     *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           3. Exit                           *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                                             *\n";
				cout << "\t***********************************************\n";
				cout << "\n\n";
          
				cout << "\t                >> "; getline(cin,input);

				boost::to_upper(input);

				if (input != "1" && input != "2" && input != "3" && input != "EXIT")
				{
					system("CLS");
					std::cout << "Please choose a valid option\n";
				}

			}while(input != "1" && input != "2" && input != "3" && input != "EXIT");

			system("CLS");

			if (input == "1")
				StatisticsSummary_STATIC();
			else if (input == "2")
				StatisticsSummary();

			system("CLS");
		}
		else if (input == "5")
		{
			system("CLS");
			do
			{
				
				cout << "\n";
				cout << "\t***********************************************\n";
				cout << "\t*                                             *\n";
				cout << "\t*   Statistics for Dynamic & Static Networks  *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                Options:                     *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           1. Static Statistics Spreadsheet  *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           2. Dynamic Statistics Spreadsheet *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           3. Exit                           *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                                             *\n";
				cout << "\t***********************************************\n";
				cout << "\n\n";
          
				cout << "\t                >> "; getline(cin,input);

				boost::to_upper(input);

				if (input != "1" && input != "2" && input != "3" && input != "EXIT")
				{
					system("CLS");
					std::cout << "Please choose a valid option\n";
				}

			}while(input != "1" && input != "2" && input != "3" && input != "EXIT");

			system("CLS");

			if (input == "1")
				SpreadsheetCreator_STATIC();
			else if (input == "2")
				SpreadsheetCreator();

			system("CLS");
		}
		else if (input == "6")
		{
			std::cout << "\nMatlab not yet implemented\n";
			std::cout << "Open 'animation_graphs.m' within Matlab to use this component of the program\n";
			system("PAUSE");
			system("CLS");
		}
		else if (input == "7")
		{
			system("CLS");
			LocationGenerator(true);
			system("CLS");
		}
		else if (input == "8" || input == "EXIT")
		{
			title = false;
			system("CLS");
		}
		else
		{
			system("CLS");
			cout << "Invalid option. Please enter a value from the list:\n";
		}

                 
	}while (title == true);
	
return 0;

}	//end main()

