//		Spreadsheet Creator
//		Chris Briglio


#include "stdafx.h"

#include "convert.h"


using namespace std;


/*
	SpreadsheetCreator function:
		Creates a .xml spreadsheet that can be opened in Microsoft Office Excel.
*/
int SpreadsheetCreator()
{

 //------------------------------------------------------------------------------VARIABLES--------------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//
   
	bool flag;

	std::string sequence = "";

	std::string pattern = "";

	std::string extension = "";

	std::string path = "";
	std::string initialpath = "";

	double temp_num = 0;

	const int max_scenario = 25;

	int runtime = 0;

	int num_scenarios = 0;		//rows

	int num_diff_nodes = 0;		//collumns

	int * diff_nodes = new int[max_amount];

	for (int i = 0; i < max_amount;i++)
	{
		diff_nodes[i] = 0;
	}


 //------------------------------------------------------------------------------PROGRAM-----------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//

	std::cout << "\n";
	std::cout << "\t***********************************************\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*             Spreadsheet Creator             *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*          Enter the path to the files        *\n";
	std::cout << "\t*          (NS2 FILES SUPPORTED ONLY)         *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*        Enter EXIT to exit to main menu      *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t***********************************************\n";
	std::cout << "\n\n";

	std::cout << "\t            >> "; getline(std::cin,path);

	exitmask = path;

	boost::to_upper(exitmask);

	if (exitmask != "EXIT")
	{

		if (path[path.length()-1] != '\\')
			path.append("\\");

		system("CLS");

		if (dirExists(path) == true)		//if path leads to valid directory
		{

			std::system("CLS");

			std::cout << "\n";
			std::cout << "\t***********************************************\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*             Spreadsheet Creator             *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*   Enter the sequence you wish to match for  *\n";
			std::cout << "\t*   (Same as sequence in Statistics Summary)  *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t***********************************************\n";
			std::cout << "\n\n";

			std::cout << "\t            >> "; getline(std::cin,sequence);

			system("CLS");

			pattern = "\\?*" + sequence + "\\?*";		//pattern for file with any extension and any word before and after the desired sequence

			std::regex rxpattern (pattern);

			std::smatch match;

			std::ifstream infile;

			infilename = path + sequence + ".summary\\files.txt";

			std::string file_names = "";

			infile.open(infilename);

			if (infile.is_open())			//read in files used
			{

				bool node_found = false;

				while(getline(infile,temp))
				{

					node_found = false;

					file_names.append(temp);

					temp.erase(0,temp.find("o")+1);

					if (num_diff_nodes > 0)
					{
						for (int i = 0; i < num_diff_nodes;i++)
						{
							if (convertToDouble(temp.substr(0,temp.find("-"))) == diff_nodes[i])
								node_found = true;
						}

						if (node_found == false)
						{
							diff_nodes[num_diff_nodes] = convertToInterger(temp);
							num_diff_nodes++;
						}

					}
					else
					{
						diff_nodes[num_diff_nodes] = convertToInterger(temp);
						num_diff_nodes++;
					}

					temp.erase(0,temp.find("-")+1);
					temp.erase(temp.find(".")+1,std::string::npos);
					if (convertToDouble(temp) > num_scenarios)
						num_scenarios = convertToInterger(temp);
				}
				infile.close();
			}
			else
			{
				system("CLS");
				std::cout << "Unable to open file_names file:\n" << infilename << "\n";
				system("PAUSE");
				system("CLS");
				return 1;
			}

			do			//put node array in order
			{
				flag = true;
				for (int i = 0; i < num_diff_nodes - 1;i++)
				{
					if (diff_nodes[i] > diff_nodes[i+1])
					{
						temp_num = diff_nodes[i];
						diff_nodes[i] = diff_nodes[i+1];
						diff_nodes[i+1] = int ( temp_num );
						flag = false;
					}
				}
			}while (flag == false);


			if (num_scenarios > max_scenario)
			{
				system("CLS");
				std::cout << "Number of scenarios exceeds limit\n";
				system("PAUSE");
				system("CLS");
				return 1;
			}

			infilename = path + sequence + ".summary\\run_time.txt";
			infile.open(infilename);

			if (infile.is_open())			//read in run time
			{
				infile >> runtime;
				infile.close();
			}
			else
			{
				system("CLS");
				std::cout << "Unable to open run time file:\n" << infilename << "\n";
				system("PAUSE");
				system("CLS");
				return 1;
			}

			double** linksaddedAVG;
			double** linkslostAVG;
			double** linksaddedTOTAL;
			double** linkslostTOTAL;
			double** componentsINITIAL;
			double** componentsFINAL;
			double** neighboursINITIAL;
			double** neighboursFINAL;
			double** pathhopsINITIAL;
			double** pathhopsFINAL;
			double** diameterhopsINITIAL;
			double** diameterhopsFINAL;

			int* collumnvalues = new int[max_amount];

			linksaddedAVG = new double*[max_amount];
			linkslostAVG = new double*[max_amount];
			linksaddedTOTAL = new double*[max_amount];
			linkslostTOTAL = new double*[max_amount];
			componentsINITIAL = new double*[max_amount];
			componentsFINAL = new double*[max_amount];
			neighboursINITIAL = new double*[max_amount];
			neighboursFINAL = new double*[max_amount];
			pathhopsINITIAL = new double*[max_amount];
			pathhopsFINAL = new double*[max_amount];
			diameterhopsINITIAL = new double*[max_amount];
			diameterhopsFINAL = new double*[max_amount];

			for (int i = 0; i < max_amount; i++)
			{
				linksaddedAVG[i] = new double[max_scenario];
				linkslostAVG[i] = new double[max_scenario];
				linksaddedTOTAL[i] = new double[max_scenario];
				linkslostTOTAL[i] = new double[max_scenario];
				componentsINITIAL[i] = new double[max_scenario];
				componentsFINAL[i] = new double[max_scenario];
				neighboursINITIAL[i] = new double[max_scenario];
				neighboursFINAL[i] = new double[max_scenario];
				pathhopsINITIAL[i] = new double[max_scenario];
				pathhopsFINAL[i] = new double[max_scenario];
				diameterhopsINITIAL[i] = new double[max_scenario];
				diameterhopsFINAL[i] = new double[max_scenario];
			}

			double initial_links = 0;

			for (int i = 0; i < max_amount; i++)		//sets arrays to null
			{
				collumnvalues[i] = 0;
				for (int a = 0; a < max_scenario;a++)
				{				
					linksaddedAVG[i][a] = 0;
					linkslostAVG[i][a] = 0;
					linksaddedTOTAL[i][a] = 0;
					linkslostTOTAL[i][a] = 0;
					linksaddedAVG[i][a] = 0;
					linkslostAVG[i][a] = 0;
					linksaddedTOTAL[i][a] = 0;
					linkslostTOTAL[i][a] = 0;
					componentsINITIAL[i][a] = 0;
					componentsFINAL[i][a] = 0;
					neighboursINITIAL[i][a] = 0;
					neighboursFINAL[i][a] = 0;
					pathhopsINITIAL[i][a] = 0;
					pathhopsFINAL[i][a] = 0;
					diameterhopsINITIAL[i][a] = 0;
					diameterhopsFINAL[i][a] = 0;
				}
			}

			int j = 0;
			int k = 0;

			bool kchange = false;

			infilename.erase(infilename.find(sequence+".summary"),std::string::npos);

			do
			{

				if (file_names != "")
				{
					infilename.erase(path.length(),std::string::npos);
					infilename.append(file_names.substr(0,file_names.find(".txt")));
					file_names.erase(0,file_names.find(".txt")+4);
					infilename.append(" output\\links.txt");

					infile.open(infilename);

					if (infile.is_open())			//get summary values
					{

						temp = infilename.substr(infilename.find("Scenario")+8,std::string::npos);
						temp.erase(temp.find("-"),std::string::npos);

						j = convertToInterger(temp);
						collumnvalues[j/10 - 1] = j;
						j = j/10 - 1;
					
						temp = infilename.substr(infilename.find("-")+1,std::string::npos);
						temp.erase(temp.find(" "),std::string::npos);

						k = convertToInterger(temp) - 1;

						infile >> temp; infile >> initial_links;

						while(temp.find("Total") == std::string::npos)
							getline(infile,temp);

						temp.erase(0,temp.find(":")+2);
						linksaddedTOTAL[j][k] = convertToDouble(temp);

						getline(infile,temp);
						temp.erase(0,temp.find(":")+2);
						linkslostTOTAL[j][k] = convertToDouble(temp);

						getline(infile,temp);
						temp.erase(0,temp.find(":")+2);
						linksaddedAVG[j][k] = convertToDouble(temp);

						getline(infile,temp);
						temp.erase(0,temp.find(":")+2);
						linkslostAVG[j][k] = convertToDouble(temp);

						infile.close();
					}
					else
					{
						system("CLS");
						std::cout << "Unable to open links file:\n" << infilename << "\n";
						system("PAUSE");
						system("CLS");
						return 1;
					}


					infilename.erase(infilename.find("links.txt"),std::string::npos);
					infilename.append("components.txt");

					infile.open(infilename);

					if (infile.is_open())			//get summary values
					{

						infile >> temp; infile >> componentsINITIAL[j][k];
						infile.close();
						infile.open(infilename);
						//std::cout << infilename << "\n";
						for (int i = 0; i < runtime;i++)
						{
							getline(infile,temp);
							//std::cout << temp << "\n";
						}
						getline(infile,temp);
						componentsFINAL[j][k] = convertToDouble(temp.substr(temp.find(" "),std::string::npos));
						infile.close();

					}
					else
					{
						system("CLS");
						std::cout << "Unable to open components file:\n" << infilename << "\n";
						system("PAUSE");
						system("CLS");
						return 1;
					}

					infilename.erase(infilename.find("components.txt"),std::string::npos);
					infilename.append("average_neighbours.txt");

					infile.open(infilename);

					if (infile.is_open())			//get summary values
					{

						infile >> temp; infile >> neighboursINITIAL[j][k];
						infile.close();
						infile.open(infilename);
						for (int i = 0; i < runtime;i++)
							getline(infile,temp);
						getline(infile,temp);
						neighboursFINAL[j][k] = convertToDouble(temp.substr(temp.find(" "),std::string::npos));
						infile.close();

					}
					else
					{
						system("CLS");
						std::cout << "Unable to open average neighbours file:\n" << infilename << "\n";
						system("PAUSE");
						system("CLS");
						return 1;
					}

					infilename.erase(infilename.find("average_neighbours.txt"),std::string::npos);
					infilename.append("average_path_length.txt");

					infile.open(infilename);

					if (infile.is_open())			//get summary values
					{

						infile >> temp; infile >> pathhopsINITIAL[j][k];
						infile.close();
						infile.open(infilename);
						for (int i = 0; i < runtime;i++)
							getline(infile,temp);
						getline(infile,temp);
						pathhopsFINAL[j][k] = convertToDouble(temp.substr(temp.find(" "),std::string::npos));
						infile.close();

					}
					else
					{
						system("CLS");
						std::cout << "Unable to open average path lengths file:\n" << infilename << "\n";
						system("PAUSE");
						system("CLS");
						return 1;
					}

					infilename.erase(infilename.find("average_path_length.txt"),std::string::npos);
					infilename.append("diameter.txt");

					infile.open(infilename);

					if (infile.is_open())			//get summary values
					{

						infile >> temp; infile >> diameterhopsINITIAL[j][k];
						infile.close();
						infile.open(infilename);
						for (int i = 0; i < runtime;i++)
							getline(infile,temp);
						getline(infile,temp);
						diameterhopsFINAL[j][k] = convertToDouble(temp.substr(temp.find(" "),std::string::npos));
						infile.close();

					}
					else
					{
						system("CLS");
						std::cout << "Unable to open diameters file:\n" << infilename << "\n";
						system("PAUSE");
						system("CLS");
						return 1;
					}

				}//end if

			}while(file_names != "");
			
			double sum = 0;

			std::string spreadsheetfilename = path + sequence + ".summary\\" + sequence + ".spreadsheet.xml";

			std::ofstream spreadsheet(spreadsheetfilename);

			if (spreadsheet.is_open())
			{

spreadsheet << "<?xml version=\"1.0\"?>\n";
spreadsheet << "<ss:Workbook xmlns:ss=\"urn:schemas-microsoft-com:office:spreadsheet\">\n";
spreadsheet << "    <ss:Styles>\n";
spreadsheet << "        <ss:Style ss:ID=\"ROW\">\n";
spreadsheet << "			<ss:Interior ss:Color=\"#C2D69A\" ss:Pattern=\"Solid\"/>\n";
spreadsheet << "        </ss:Style>\n";
spreadsheet << "        <ss:Style ss:ID=\"COLUMN\">\n";
spreadsheet << "			<ss:Interior ss:Color=\"#D7E4BC\" ss:Pattern=\"Solid\"/>\n";
spreadsheet << "        </ss:Style>\n";
spreadsheet << "        <ss:Style ss:ID=\"HEADER\">\n";
spreadsheet << "            <ss:Font ss:Size=\"18\" ss:FontName=\"Calibri\"/>\n";
spreadsheet << "        </ss:Style>\n";
spreadsheet << "    </ss:Styles>\n";



spreadsheet << "	<ss:Worksheet ss:Name=\" Stats over Simulation Run" << "\">\n";
spreadsheet << "		<ss:Table>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average # Links Created per second</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=linksaddedAVG[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << linksaddedAVG[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average # Links Broken per second</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=linkslostAVG[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << linkslostAVG[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Total Links Created in " << runtime << "s</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=linksaddedTOTAL[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << linksaddedTOTAL[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Total Links Broken in " << runtime << "s</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=linkslostTOTAL[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << linkslostTOTAL[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "		</ss:Table>\n";
spreadsheet << "	</ss:Worksheet>\n";




spreadsheet << "	<ss:Worksheet ss:Name=\"Stats at 1 Second" << "\">\n";
spreadsheet << "		<ss:Table>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Number of Connected Components</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=componentsINITIAL[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << componentsINITIAL[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average Number of Neighbours</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=neighboursINITIAL[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << neighboursINITIAL[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average Path Length (Hops)</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=pathhopsINITIAL[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << pathhopsINITIAL[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Network Diameter (Hops)</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=diameterhopsINITIAL[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diameterhopsINITIAL[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "		</ss:Table>\n";
spreadsheet << "	</ss:Worksheet>\n";



spreadsheet << "	<ss:Worksheet ss:Name=\"Stats at " << runtime << " Seconds" << "\">\n";
spreadsheet << "		<ss:Table>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Number of Connected Components</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=componentsFINAL[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << componentsFINAL[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average Number of Neighbours</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=neighboursFINAL[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << neighboursFINAL[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average Path Length (Hops)</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=pathhopsFINAL[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << pathhopsFINAL[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Network Diameter (Hops)</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=diameterhopsFINAL[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diameterhopsFINAL[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "		</ss:Table>\n";
spreadsheet << "	</ss:Worksheet>\n";

spreadsheet << "</ss:Workbook>\n";


				spreadsheet.close();
			}
			else
			{
				system("CLS");
				std::cout << "Unable to create spreadsheet:\n" << spreadsheetfilename << "\n";
				system("PAUSE");
				system("CLS");
			}

			for (int i = 0; i < max_amount; i++)
			{
				delete [] linksaddedAVG[i];
				delete [] linksaddedTOTAL[i];
				delete [] linkslostTOTAL[i];
				delete [] linkslostAVG[i];
				delete [] componentsINITIAL[i];
				delete [] componentsFINAL[i];
				delete [] neighboursINITIAL[i];
				delete [] neighboursFINAL[i];
				delete [] pathhopsINITIAL[i];
				delete [] pathhopsFINAL[i];
				delete [] diameterhopsINITIAL[i];
				delete [] diameterhopsFINAL[i];
			}

			delete [] linksaddedAVG;
			delete [] linksaddedTOTAL;
			delete [] linkslostTOTAL;
			delete [] linkslostAVG;
			delete [] componentsINITIAL;
			delete [] componentsFINAL;
			delete [] neighboursINITIAL;
			delete [] neighboursFINAL;
			delete [] pathhopsINITIAL;
			delete [] pathhopsFINAL;
			delete [] diameterhopsINITIAL;
			delete [] diameterhopsFINAL;
			delete [] collumnvalues;


		}
		else
		{
			system("CLS");
			std::cout << "\n\nThe file path is not valid\n\n";
			std::system("PAUSE");
			system("CLS");
		}

	}//end if
	else
		return 0;



	return 0;

}	//end SpreadsheetCreator()


/*
	SpreadsheetCreator_STATIC function:
		Creates a .xml spreadsheet that can be opened in Microsoft Office Excel.
*/
int SpreadsheetCreator_STATIC()
{

 //------------------------------------------------------------------------------VARIABLES--------------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//
   
	bool flag;

	std::string sequence = "";

	std::string pattern = "";

	std::string extension = "";

	std::string path = "";
	std::string initialpath = "";

	double temp_num = 0;

	const int max_scenario = 25;

	int runtime = 0;

	int num_scenarios = 0;		//rows

	int num_diff_nodes = 0;		//collumns

	int * diff_nodes = new int[max_amount];

	for (int i = 0; i < max_amount;i++)
	{
		diff_nodes[i] = 0;
	}


 //------------------------------------------------------------------------------PROGRAM-----------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//

	std::cout << "\n";
	std::cout << "\t***********************************************\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*             Spreadsheet Creator             *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*          Enter the path to the files        *\n";
	std::cout << "\t*          (NS2 FILES SUPPORTED ONLY)         *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*        Enter EXIT to exit to main menu      *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t***********************************************\n";
	std::cout << "\n\n";

	std::cout << "\t            >> "; getline(std::cin,path);

	exitmask = path;

	boost::to_upper(exitmask);

	if (exitmask != "EXIT")
	{

		if (path[path.length()-1] != '\\')
			path.append("\\");

		system("CLS");

		if (dirExists(path) == true)		//if path leads to valid directory
		{

			std::system("CLS");

			std::cout << "\n";
			std::cout << "\t***********************************************\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*             Spreadsheet Creator             *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*   Enter the sequence you wish to match for  *\n";
			std::cout << "\t*   (Same as sequence in Statistics Summary)  *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t***********************************************\n";
			std::cout << "\n\n";

			std::cout << "\t            >> "; getline(std::cin,sequence);

			system("CLS");

			pattern = "\\?*" + sequence + "\\?*";		//pattern for file with any extension and any word before and after the desired sequence

			std::regex rxpattern (pattern);

			std::smatch match;

			std::ifstream infile;

			infilename = path + sequence + ".summary\\files.txt";

			std::string file_names = "";

			infile.open(infilename);

			if (infile.is_open())			//read in files used
			{

				bool node_found = false;

				while(getline(infile,temp))
				{

					node_found = false;

					file_names.append(temp);

					temp.erase(0,temp.find("o")+1);

					if (num_diff_nodes > 0)
					{
						for (int i = 0; i < num_diff_nodes;i++)
						{
							if (convertToDouble(temp.substr(0,temp.find("-"))) == diff_nodes[i])
								node_found = true;
						}

						if (node_found == false)
						{
							diff_nodes[num_diff_nodes] = convertToInterger(temp);
							num_diff_nodes++;
						}

					}
					else
					{
						diff_nodes[num_diff_nodes] = convertToInterger(temp);
						num_diff_nodes++;
					}

					temp.erase(0,temp.find("-")+1);
					temp.erase(temp.find(".")+1,std::string::npos);
					if (convertToDouble(temp) > num_scenarios)
						num_scenarios = convertToInterger(temp);
				}
				infile.close();
			}
			else
			{
				system("CLS");
				std::cout << "Unable to open file_names file:\n" << infilename << "\n";
				system("PAUSE");
				system("CLS");
				return 1;
			}

			do			//put node array in order
			{
				flag = true;
				for (int i = 0; i < num_diff_nodes - 1;i++)
				{
					if (diff_nodes[i] > diff_nodes[i+1])
					{
						temp_num = diff_nodes[i];
						diff_nodes[i] = diff_nodes[i+1];
						diff_nodes[i+1] = int ( temp_num );
						flag = false;
					}
				}
			}while (flag == false);


			if (num_scenarios > max_scenario)
			{
				system("CLS");
				std::cout << "Number of scenarios exceeds limit\n";
				system("PAUSE");
				system("CLS");
				return 1;
			}

			double** components;
			double** neighbours;
			double** pathhops;
			double** diameterhops;

			int* collumnvalues = new int[max_amount];

			components = new double*[max_amount];
			neighbours = new double*[max_amount];
			pathhops = new double*[max_amount];
			diameterhops = new double*[max_amount];

			for (int i = 0; i < max_amount; i++)
			{
				components[i] = new double[max_scenario];
				neighbours[i] = new double[max_scenario];
				pathhops[i] = new double[max_scenario];
				diameterhops[i] = new double[max_scenario];
			}

			double initial_links = 0;

			for (int i = 0; i < max_amount; i++)		//sets arrays to null
			{
				collumnvalues[i] = 0;
				for (int a = 0; a < max_scenario;a++)
				{				
					components[i][a] = 0;
					neighbours[i][a] = 0;
					pathhops[i][a] = 0;
					diameterhops[i][a] = 0;
				}
			}

			int j = 0;
			int k = 0;

			bool kchange = false;

			infilename.erase(infilename.find(sequence+".summary"),std::string::npos);

			do
			{

				if (file_names != "")
				{
					infilename.erase(path.length(),std::string::npos);
					infilename.append(file_names.substr(0,file_names.find(".txt")));
					file_names.erase(0,file_names.find(".txt")+4);
					infilename.append(" output\\components.txt");

					infile.open(infilename);

					if (infile.is_open())			//get summary values
					{

						temp = infilename.substr(infilename.find("Scenario")+8,std::string::npos);
						temp.erase(temp.find("-"),std::string::npos);

						j = convertToInterger(temp);
						collumnvalues[j/10 - 1] = j;
						j = j/10 - 1;
					
						temp = infilename.substr(infilename.find("-")+1,std::string::npos);
						temp.erase(temp.find(" "),std::string::npos);

						k = convertToInterger(temp) - 1;

						infile >> components[j][k];
						infile.close();

					}
					else
					{
						system("CLS");
						std::cout << "Unable to open components file:\n" << infilename << "\n";
						system("PAUSE");
						system("CLS");
						return 1;
					}

					infilename.erase(infilename.find("components.txt"),std::string::npos);
					infilename.append("average_neighbours.txt");

					infile.open(infilename);

					if (infile.is_open())			//get summary values
					{

						infile >> neighbours[j][k];
						infile.close();
			
					}
					else
					{
						system("CLS");
						std::cout << "Unable to open average neighbours file:\n" << infilename << "\n";
						system("PAUSE");
						system("CLS");
						return 1;
					}

					infilename.erase(infilename.find("average_neighbours.txt"),std::string::npos);
					infilename.append("average_path_length.txt");

					infile.open(infilename);

					if (infile.is_open())			//get summary values
					{

						infile >> pathhops[j][k];
						infile.close();

					}
					else
					{
						system("CLS");
						std::cout << "Unable to open average path lengths file:\n" << infilename << "\n";
						system("PAUSE");
						system("CLS");
						return 1;
					}

					infilename.erase(infilename.find("average_path_length.txt"),std::string::npos);
					infilename.append("diameter.txt");

					infile.open(infilename);

					if (infile.is_open())			//get summary values
					{

						infile >> diameterhops[j][k];
						infile.close();

					}
					else
					{
						system("CLS");
						std::cout << "Unable to open diameters file:\n" << infilename << "\n";
						system("PAUSE");
						system("CLS");
						return 1;
					}

				}//end if

			}while(file_names != "");
			
			double sum = 0;

			std::string spreadsheetfilename = path + sequence + ".summary\\" + sequence + ".spreadsheet.xml";

			std::ofstream spreadsheet(spreadsheetfilename);

			if (spreadsheet.is_open())
			{

spreadsheet << "<?xml version=\"1.0\"?>\n";
spreadsheet << "<ss:Workbook xmlns:ss=\"urn:schemas-microsoft-com:office:spreadsheet\">\n";
spreadsheet << "    <ss:Styles>\n";
spreadsheet << "        <ss:Style ss:ID=\"ROW\">\n";
spreadsheet << "			<ss:Interior ss:Color=\"#C2D69A\" ss:Pattern=\"Solid\"/>\n";
spreadsheet << "        </ss:Style>\n";
spreadsheet << "        <ss:Style ss:ID=\"COLUMN\">\n";
spreadsheet << "			<ss:Interior ss:Color=\"#D7E4BC\" ss:Pattern=\"Solid\"/>\n";
spreadsheet << "        </ss:Style>\n";
spreadsheet << "        <ss:Style ss:ID=\"HEADER\">\n";
spreadsheet << "            <ss:Font ss:Size=\"18\" ss:FontName=\"Calibri\"/>\n";
spreadsheet << "        </ss:Style>\n";
spreadsheet << "    </ss:Styles>\n";


spreadsheet << "	<ss:Worksheet ss:Name=\"Static Stats" << "\">\n";
spreadsheet << "		<ss:Table>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Number of Connected Components</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=components[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << components[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average Number of Neighbours</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=neighbours[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << neighbours[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average Path Length (Hops)</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=pathhops[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << pathhops[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"HEADER\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Network Diameter (Hops)</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "			</ss:Row>\n";
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Nodes</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"String\">Average</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				for (int i = 0; i < num_scenarios;i++)
				{
spreadsheet << "				<ss:Cell ss:StyleID=\"ROW\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << i+1 << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
				}
spreadsheet << "			</ss:Row>\n";
				for (int i = 0; i < num_diff_nodes;i++)
				{
spreadsheet << "			<ss:Row>\n";
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diff_nodes[i] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					sum = 0;
					for (int b = 0; b < num_scenarios;b++)
						sum+=diameterhops[i][b];
					sum = sum/num_scenarios;
spreadsheet << "				<ss:Cell ss:StyleID=\"COLUMN\">\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << sum << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";
					for (int a = 0; a < num_scenarios;a++)
					{	
spreadsheet << "				<ss:Cell>\n";
spreadsheet << "					<ss:Data ss:Type=\"Number\">" << diameterhops[i][a] << "</ss:Data>\n";
spreadsheet << "				</ss:Cell>\n";	
					}
spreadsheet << "			</ss:Row>\n";
				}
spreadsheet << "		</ss:Table>\n";
spreadsheet << "	</ss:Worksheet>\n";

spreadsheet << "</ss:Workbook>\n";


				spreadsheet.close();
			}
			else
			{
				system("CLS");
				std::cout << "Unable to create spreadsheet:\n" << spreadsheetfilename << "\n";
				system("PAUSE");
				system("CLS");
			}

			for (int i = 0; i < max_amount; i++)
			{
				delete [] components[i];
				delete [] neighbours[i];
				delete [] pathhops[i];
				delete [] diameterhops[i];
			}

			delete [] components;
			delete [] neighbours;
			delete [] pathhops;
			delete [] diameterhops;
			delete [] collumnvalues;


		}
		else
		{
			system("CLS");
			std::cout << "\n\nThe file path is not valid\n\n";
			std::system("PAUSE");
			system("CLS");
		}

	}//end if
	else
		return 0;



	return 0;

}	//end SpreadsheetCreator()

