//		Static Statistics
//		Originally by Hassain Saeed
//		Chris Briglio

#define NOMINMAX

#include "stdafx.h"

#include "convert.h"

#include "boost\foreach.hpp"

#include "boost\tokenizer.hpp"

#include <boost/graph/adjacency_list.hpp>

#include <boost/graph/connected_components.hpp>

#include <boost\graph\betweenness_centrality.hpp>


 //------------------------------------------------------------------------------GLOBAL VARIABLES-------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


static double transmissonrange;

std::string visualizationanswer;

bool visualization = false;

std::ofstream myoutfile;


 //------------------------------------------------------------------------------FUNCTION HEADERS-------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


void Static_NS2(std::string path2);

void Static_OPNET(std::string path2);

void Static_CORE(std::string path2);

void transmission();


 //------------------------------------------------------------------------------STATIC STATISTICS-----------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//

using namespace boost;


/*
	StaticStatistics function:
		Reads static network simulations of NS2, Opnet & Core types. The creates statistics from these scenarios
*/
int StaticStatistics()
{

 //------------------------------------------------------------------------------VARIABLES--------------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//

	bool exitflag = false;

	inputmode = "";

	num_nodes = 0;

	folderPath = "";

	visualization = false;

	std::string searchextension = "";

  //------------------------------------------------------------------------------PROGRAM----------------------------------------------------------------------------------------------//

  //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


#pragma region

	do		// main program do-while loop, insures program continues until user specifies exit (flag: exitflag)
	{

		system("CLS");

		//Ask for the user to input the file type
		do 
		{		
  
			std::cout << "\n";
			std::cout << "\t***********************************************\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*             Static Statistics               *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*     File types supported:                   *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*      NS2   (single file & multiple files)   *\n";
			std::cout << "\t*      OPNET (single file)                    *\n";
			std::cout << "\t*      CORE  (single file)                    *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*      Enter EXIT to exit to main menu        *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t***********************************************\n";
			std::cout << "\n\n";
          
			std::cout << "\t          File Type: >> "; std::getline(std::cin,filetype);
		
			to_upper(filetype);

			if(filetype != "NS2" && filetype != "OPNET" && filetype != "CORE" && filetype != "EXIT")
			{
				system("CLS");
				std::cout << "The file type you have entered is unrecognizable, please try again.\n" << std::endl;
			}

		}while (filetype != "NS2" && filetype != "OPNET" && filetype != "CORE" && filetype != "EXIT");

		if (filetype != "EXIT")
		{

			if (filetype == "NS2")
				extension = ".txt";
			if (filetype == "OPNET")
				extension = ".xml";
			if (filetype == "CORE")
				extension = ".imn";
		
			system("CLS");

			do
			{

				//Ask for user to choose between single and multi-file intake

				std::cout << "\n";
				std::cout << "\t***********************************************\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*             Static Statistics               *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*             Choose an option:               *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*              1. Single file                 *\n";
				std::cout << "\t*              2. Multiple files              *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*      Enter EXIT to exit to main menu        *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t***********************************************\n";
				std::cout << "\n\n";

				std::cout << "\t                 >> "; std::getline(std::cin,inputmode);

				if (inputmode != "1" && inputmode != "2" && inputmode != "EXIT")
				{
					system("CLS");
					std::cout << "That option is not available, please choose a valid option,\n";
				}

			}while (inputmode != "1" && inputmode != "2" && inputmode != "EXIT");

			if (inputmode == "EXIT")
				return 0;

		}//end if

#pragma endregion


  //------------------------------------------------------------------------------SINGLE FILE--------------------------------------------------------------------------------------//

  //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


#pragma region
		if (inputmode == "1") 
		{

			system("CLS");
			do
			{

				std::cout << "\n";
				std::cout << "\t***********************************************\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*             Static Statistics               *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*         Enter the name of the file          *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*      Enter EXIT to exit to main menu        *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t***********************************************\n";
				std::cout << "\n\n";

				std::cout << "\t                  >> "; std::getline (std::cin,infilename);//Ask for the name of the file they want to use

				exitmask = infilename; to_upper(exitmask);

				if (exitmask == "EXIT")
					return 0;

				if (checkEXT(infilename) == false) 
				{ 
					std::system("CLS");
					std::cout << "Unrecognizable file type.\n"; 
				}

			}while (checkEXT(infilename) == false);

			txt_index = infilename.find(extension);

			create_folder("");
  
			transmission();

			if (transmissonrange == -1)
				return 0;

			outfilename = infilename.erase(txt_index) + " output\\";

			do
			{
			
				std::cout << "\n";
				std::cout << "\t***********************************************\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*             Static Statistics               *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*            Do you wish to make a            *\n";
				std::cout << "\t*       graphViz Visualization? (Yes/No)      *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*      Enter EXIT to exit to main menu        *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t***********************************************\n";
				std::cout << "\n\n";

				std::cout << "\t                   >> "; std::getline(std::cin,visualizationanswer);

				to_upper(visualizationanswer);

				if (visualizationanswer != "YES" && visualizationanswer != "NO" && visualizationanswer != "EXIT")
				{
					std::system("CLS");
					std::cout << "Please answer Yes or No\n";
				}

			} while (visualizationanswer != "YES" && visualizationanswer != "NO" && visualizationanswer != "EXIT");

			if (visualizationanswer == "YES") 
			{
				visualization = true;
				outfilename.append("graphViz_static.dot");
			} 
			else if (visualizationanswer == "NO")
			{
				visualization = false;
			}
			else 
				return 0;

			infilename.append(extension);

			if (filetype == "NS2")
				Static_NS2("");
			else if (filetype == "OPNET")
				Static_OPNET("");
			else if (filetype == "CORE")
				Static_CORE("");

		 }
#pragma endregion


 //--------------------------------------------------------------------------------MULTIPLE FILES-----------------------------------------------------------------------------------//

 //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


#pragma region
		else if (inputmode == "2") 
		{

			system("CLS");

			std::string path = "";

			if (filetype == "NS2")
				searchextension = "\\*.txt";
			if (filetype == "OPNET")
				searchextension = "\\*.xml";
			if (filetype == "CORE")
				searchextension = "\\*.imn";

			std::cout << "\n";
			std::cout << "\t***********************************************\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*             Static Statistics               *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*       Enter file path to folder you         *\n";
			std::cout << "\t*                wish to use                  *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*      Enter EXIT to exit to main menu        *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t***********************************************\n";
			std::cout << "\n\n";

			std::cout << "\t                    >> "; std::getline(std::cin, path);

			exitmask = path; to_upper(exitmask);

			if (exitmask == "EXIT")
				return 0;

			std::string fullpath = path + searchextension;

			WIN32_FIND_DATA FData;
			HANDLE hFind;

			hFind = FindFirstFile( fullpath.c_str(), &FData );

			if( hFind == INVALID_HANDLE_VALUE )
			{
				system("CLS");
				std::cout << "\n\nThe file path is not valid\n\n";
				std::system("PAUSE");
				system("CLS");
			}
			else
			{

				system("CLS");

				std::cout << "\nFile path " << path << " has been located.\n\n";


				path.append("\\");

				transmission();
				if (transmissonrange == -1)
					return 0;

				do
				{
			
					std::cout << "\n";
					std::cout << "\t***********************************************\n";
					std::cout << "\t*                                             *\n";
					std::cout << "\t*             Static Statistics               *\n";
					std::cout << "\t*                                             *\n";
					std::cout << "\t*                                             *\n";
					std::cout << "\t*            Do you wish to make a            *\n";
					std::cout << "\t*       graphViz Visualization? (Yes/No)      *\n";
					std::cout << "\t*                                             *\n";
					std::cout << "\t*      Enter EXIT to exit to main menu        *\n";
					std::cout << "\t*                                             *\n";
					std::cout << "\t***********************************************\n";
					std::cout << "\n\n";

					std::cout << "\t                   >> "; std::getline(std::cin,visualizationanswer);

					to_upper(visualizationanswer);

					if (visualizationanswer != "YES" && visualizationanswer != "NO" && visualizationanswer != "EXIT")
					{
						std::system("CLS");
						std::cout << "Please answer Yes or No\n";
					}

				} while (visualizationanswer != "YES" && visualizationanswer != "NO" && visualizationanswer != "EXIT");

				if (visualizationanswer == "EXIT")
					return 0;

				do		//do-while loop: loops while files are still being located
				{

					std::string filePath = path + FData.cFileName;
					std::ifstream checkfile(filePath);
			
					if( checkfile.is_open() )		//if file has be found
					{

						infilename = FData.cFileName;

						if (infilename.find("_out.txt") != std::string::npos) continue;	//if an output file skip it

						txt_index = infilename.find(extension);


						std::string fullfolderPath = "";		//create output folder

						folderPath = "";

						fullfolderPath.append(path);

						fullfolderPath.append(infilename.erase(txt_index));

						fullfolderPath.append(" output\\");

						create_folder(path);

						outfilename = infilename.erase(txt_index) + " output\\";

						if (visualizationanswer == "YES") 
						{
							visualization = true;
							outfilename.append("graphViz_static.dot");
						} 
						else 
						{
							visualization = false;
						}

						infilename.append(extension);

						if (filetype == "NS2")
							Static_NS2(path);
						else if (filetype == "OPNET")
							Static_OPNET(path);
						else if (filetype == "CORE")
							Static_CORE(path);

					}
					else
					{
						std::cout << "\n\nCould not open file " << FData.cFileName << "\n\n";
					}

				}while( FindNextFile(hFind, &FData) > 0 );
 
				if( GetLastError() != ERROR_NO_MORE_FILES )
				{
					std::cout << "\n\nERROR: did not reach end of files\n\n";
					std::cout << "Last file read " << FData.cFileName << "\n\n";
					std::system("PAUSE");
				}

			}	// end if

		}
#pragma endregion


 //------------------------------------------------------------------------------EXIT-------------------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//
 
		else if (filetype == "EXIT") 
		{
			exitflag = true;
		}

	}while(exitflag== false);

	return 0;

}	//end StaticStatistics()


/*
	StatisticsSummary_STATIC function:
		Creates a summary of a batch of static scenarioes statistics
*/
int StatisticsSummary_STATIC()
{


 //------------------------------------------------------------------------------VARIABLES--------------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//
   
	double matches = 0;

	int curr = 0;

	int refresh_rate = 0;

	std::string path = "";
	std::string initialpath = "";

	std::string sequence = "";

	std::string filePath1 = "";
	std::string filePath2 = "";

	std::string filename1 = "";
	std::string filename2 = "";

	std::string pattern = "";

 //------------------------------------------------------------------------------PROGRAM-----------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


	std::cout << "\n";
	std::cout << "\t***********************************************\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*             Statistics Summary              *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*          Enter the path to the files        *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t*        Enter EXIT to exit to main menu      *\n";
	std::cout << "\t*                                             *\n";
	std::cout << "\t***********************************************\n";
	std::cout << "\n\n";

	std::cout << "\t            >> "; getline(std::cin,path);

	exitmask = path;

	to_upper(exitmask);

	if (exitmask != "EXIT")
	{

		if (path[path.length()-1] != '\\')
			path.append("\\");

		system("CLS");

		if (dirExists(path) == true)		//if path leads to valid directory
		{

			do 
			{		
  
				std::cout << "\n";
				std::cout << "\t***********************************************\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*             Statistics Summary              *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*            Choose the file type             *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*                   NS2                       *\n";
				std::cout << "\t*                  OPNET                      *\n";
				std::cout << "\t*                  CORE                       *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t*        Enter EXIT to exit to main menu      *\n";
				std::cout << "\t*                                             *\n";
				std::cout << "\t***********************************************\n";
				std::cout << "\n\n";
          
				std::cout << "\t          File Type: >> "; std::getline(std::cin,filetype);
		
 
				to_upper(filetype);

				if(filetype != "NS2" && filetype != "OPNET" && filetype != "CORE" && filetype != "EXIT")
				{
					system("CLS");
					std::cout << "The file type you have entered is unrecognizable, please try again.\n" << std::endl;
				}

			}while (filetype != "NS2" && filetype != "OPNET" && filetype != "CORE" && filetype != "EXIT");


			if (filetype == "NS2")
				extension = "*.txt";
			else if (filetype == "OPNET")
				extension = "*.xml";
			else if (filetype == "CORE")
				extension = "*.scen";
			else if (filetype != "EXIT")
				return 0;


			initialpath = path + extension;


			std::system("CLS");

			std::cout << "\n";
			std::cout << "\t***********************************************\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*             Statistics Summary              *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*   Enter the sequence you wish to match for  *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t*        Enter EXIT to exit to main menu      *\n";
			std::cout << "\t*                                             *\n";
			std::cout << "\t***********************************************\n";
			std::cout << "\n\n";

			std::cout << "\t            >> "; getline(std::cin,sequence);

			exitmask = sequence; to_upper(exitmask);

			if (exitmask == "EXIT")
				return 0;

			pattern = "\\?*" + sequence + "\\?*";		//pattern for file with any extension and any word before and after the desired sequence

			system("CLS");

			double* components = new double[2];
			double* neighbours = new double[2];
			double* pathlengths = new double[4];
			double* diameters = new double[4];

			components[0] = 0;
			neighbours[0] = 0;	
			pathlengths[0] = 0;
			diameters[0] = 0;
			components[1] = 0;
			neighbours[1] = 0;	
			pathlengths[1] = 0;
			diameters[1] = 0;
			pathlengths[2] = 0;
			diameters[2] = 0;
			pathlengths[3] = 0;
			diameters[3] = 0;

			double* componentsSUM = new double;
			double* neighboursSUM = new double;
			double* pathlengthsSUM_hops = new double;
			double* diametersSUM_hops = new double;
			double* pathlengthsSUM_meters = new double;
			double* diametersSUM_meters = new double;

			*componentsSUM = 0;
			*neighboursSUM = 0;
			*pathlengthsSUM_hops = 0;
			*diametersSUM_hops = 0;
			*pathlengthsSUM_meters = 0;
			*diametersSUM_meters = 0;			
			


			std::string file_names = "";

			std::regex rxpattern (pattern);

			std::smatch match;

			WIN32_FIND_DATA FData;
			HANDLE hFind;

			hFind = FindFirstFile( initialpath.c_str(), &FData );

			if( hFind == INVALID_HANDLE_VALUE )
			{
				system("CLS");
				std::cout << "\n\nInvalid handle\n\n";
				std::system("PAUSE");
				system("CLS");
				return 1;
			}
			else    //path was found
			{

				std::cout << "Beginning to search folder...\n";

				int runtime_check = 0;

				std::ifstream infile1;
				std::ifstream infile2;

				do		//do-while loop: loops while files are still being located
				{

					filename1 = FData.cFileName;

					if (std::regex_search (filename1,match,rxpattern) == true)	//if first file name contains sequence of search
					{

						file_names.append(filename1 + "\n");

						filePath1 = path + filename1;
						matches++;
						filePath1.erase(filePath1.find("."),std::string::npos);
						filePath1.append(" output\\");

						system("CLS");
						std::cout << "Beginning to search folder...\n";
						std::cout << matches << " files found\n";

						do 
						{

							FindNextFile(hFind, &FData);
							filename2 = FData.cFileName;	

							if (std::regex_search (filename2,match,rxpattern) == true && filename2 != filename1)	//if second file name contains sequence of search
							{

								file_names.append(filename2 + "\n");

								filePath2 = path + filename2;
								matches++;
								filePath2.erase(filePath2.find("."),std::string::npos);
								filePath2.append(" output\\");

								system("CLS");
								std::cout << "Beginning to search folder...\n";
								std::cout << matches << " files found\n";


								filePath1.append("components.txt");		//read in components
								filePath2.append("components.txt");

								infile1.open(filePath1);

								if (infile1.is_open())
								{
									
									infile1 >> components[0];
									
									infile1.close();
								}
								else
								{
									system("CLS");
									std::cout << "Unable to open components file:\n";
									std::cout << filePath1 << "\n";
									std::system("PAUSE");
									system("CLS");
									return 1;
								}

								infile2.open(filePath2);

								if (infile2.is_open())
								{
									
									infile2 >> components[1];
									
									infile2.close();
								}
								else
								{
									system("CLS");
									std::cout << "Unable to open components file:\n";
									std::cout << filePath2 << "\n";
									std::system("PAUSE");
									system("CLS");
									return 1;
								}


								filePath1.erase(filePath1.find("components.txt"),std::string::npos);
								filePath2.erase(filePath2.find("components.txt"),std::string::npos);


								filePath1.append("average_neighbours.txt");		//read in average neighbours
								filePath2.append("average_neighbours.txt");

								infile1.open(filePath1);

								if (infile1.is_open())
								{
									
									infile1 >> neighbours[0];
									
									infile1.close();
								}
								else
								{
									system("CLS");
									std::cout << "Unable to open average neighbours file:\n";
									std::cout << filePath1 << "\n";
									std::system("PAUSE");
									system("CLS");
									return 1;
								}

								infile2.open(filePath2);

								if (infile2.is_open())
								{
									
									infile2 >> neighbours[1];
									
									infile2.close();
								}
								else
								{
									system("CLS");
									std::cout << "Unable to open average neighbours file:\n";
									std::cout << filePath2 << "\n";
									std::system("PAUSE");
									system("CLS");
									return 1;
								}


								filePath1.erase(filePath1.find("average_neighbours.txt"),std::string::npos);
								filePath2.erase(filePath2.find("average_neighbours.txt"),std::string::npos);


								filePath1.append("diameter.txt");		//read in diameters
								filePath2.append("diameter.txt");

								infile1.open(filePath1);

								if (infile1.is_open())
								{
									
									infile1 >> diameters[0]; infile1 >> diameters[1];
									
									infile1.close();
								}
								else
								{
									system("CLS");
									std::cout << "Unable to open diameter file:\n";
									std::cout << filePath1 << "\n";
									std::system("PAUSE");
									system("CLS");
									return 1;
								}

								infile2.open(filePath2);

								if (infile2.is_open())
								{
									
									infile2 >> diameters[2]; infile2 >> diameters[3];
									
									infile2.close();
								}
								else
								{
									system("CLS");
									std::cout << "Unable to open diameter file:\n";
									std::cout << filePath2 << "\n";
									std::system("PAUSE");
									system("CLS");
									return 1;
								}

								filePath1.erase(filePath1.find("diameter.txt"),std::string::npos);
								filePath2.erase(filePath2.find("diameter.txt"),std::string::npos);


								filePath1.append("average_path_length.txt");		//read in path lengths
								filePath2.append("average_path_length.txt");

								infile1.open(filePath1);

								if (infile1.is_open())
								{
									
									infile1 >> pathlengths[0]; infile1 >> pathlengths[1];
									
									infile1.close();
								}
								else
								{
									system("CLS");
									std::cout << "Unable to open path lengths file:\n";
									std::cout << filePath1 << "\n";
									std::system("PAUSE");
									system("CLS");
									return 1;
								}

								infile2.open(filePath2);

								if (infile2.is_open())
								{
									
									infile2 >> pathlengths[2]; infile2 >> pathlengths[3];
									
									infile2.close();
								}
								else
								{
									system("CLS");
									std::cout << "Unable to open path lengths file:\n";
									std::cout << filePath2 << "\n";
									std::system("PAUSE");
									system("CLS");
									return 1;
								}

								filePath1.erase(filePath1.find("average_path_length.txt"),std::string::npos);
								filePath2.erase(filePath2.find("average_path_length.txt"),std::string::npos);

								*componentsSUM += (components[0] + components[1])/2;
								*neighboursSUM += (neighbours[0] + neighbours[1])/2;
								*pathlengthsSUM_hops += (pathlengths[0] + pathlengths[2])/2;
								*pathlengthsSUM_meters += (pathlengths[1] + pathlengths[3])/2;
								*diametersSUM_hops += (diameters[0] + diameters[2])/2;
								*diametersSUM_meters += (diameters[1] + diameters[3])/2;

								components[0] = 0;
								neighbours[0] = 0;	
								pathlengths[0] = 0;
								diameters[0] = 0;
								components[1] = 0;
								neighbours[1] = 0;	
								pathlengths[1] = 0;
								diameters[1] = 0;
								pathlengths[2] = 0;
								diameters[2] = 0;
								pathlengths[3] = 0;
								diameters[3] = 0;

							}	//end if

						}while(std::regex_search (filename2,match,rxpattern) == false && GetLastError() != ERROR_NO_MORE_FILES);

					}	//end if

				}while( FindNextFile(hFind, &FData) > 0 );
 
				if( GetLastError() != ERROR_NO_MORE_FILES )
				{
					std::cout << "\n\nERROR: did not reach end of files\n\n";
					std::cout << "Last file read " << FData.cFileName << "\n\n";
					std::system("PAUSE");
					system("CLS");
				}

				if (matches > 1)
				{

					*componentsSUM += (components[0] + components[1])/2;
					*neighboursSUM += (neighbours[0] + neighbours[1])/2;
					*pathlengthsSUM_hops += (pathlengths[0] + pathlengths[2])/2;
					*pathlengthsSUM_meters += (pathlengths[1] + pathlengths[3])/2;
					*diametersSUM_hops += (diameters[0] + diameters[2])/2;
					*diametersSUM_meters += (diameters[1] + diameters[3])/2;



					matches = matches / 2;

					*componentsSUM = *componentsSUM / matches;
					*neighboursSUM = *neighboursSUM / matches;
					*pathlengthsSUM_hops = *pathlengthsSUM_hops / matches;
					*diametersSUM_hops = *diametersSUM_hops / matches;
					*pathlengthsSUM_meters = *pathlengthsSUM_meters / matches;
					*diametersSUM_meters = *diametersSUM_meters / matches;
		

							//write to output file

					system("CLS");
					std::cout << "Creating ouput files...\n";

					std::ofstream outfile;

					std::string folderpath = path + sequence +".summary";

					if (CreateDirectory(folderpath.c_str(),NULL) == 0)			//check for errors
					{
						if (ERROR_PATH_NOT_FOUND == GetLastError())	
						{
							std::cout << "\nError: path for folder creation not found.\n";
			
							folderpath = "";		//sets folder path to nothing so file will be written in same directory as input file
						}
						else if (ERROR_ALREADY_EXISTS == GetLastError())
						{
							std::cout << "\n" << folderpath << " already exists.\nOutput file will be created within the folder.\n";
						}
					}

					folderpath.append("\\");

					std::string fulloutname = folderpath + "components_summary.txt";

					outfile.open(fulloutname);			//output components summary

					if (outfile.is_open())
					{

						outfile << *componentsSUM;

						outfile.close();

					}
					else
					{
						std::cout << "Unable to create output file:\n" << fulloutname << "\n";
					}

					fulloutname.erase(fulloutname.find("components_summary.txt"),std::string::npos);
					fulloutname.append("average_neighbours_summary.txt");

					outfile.open(fulloutname);		//output neighbours summary

					if (outfile.is_open())
					{

						outfile << *neighboursSUM;

						outfile.close();

					}
					else
					{
						std::cout << "Unable to create output file:\n" << fulloutname << "\n";
					}


					fulloutname.erase(fulloutname.find("average_neighbours_summary.txt"),std::string::npos);
					fulloutname.append("average_path_length_summary.txt");

					outfile.open(fulloutname);		//output path length summary

					if (outfile.is_open())
					{

						outfile << *pathlengthsSUM_hops << " " << *pathlengthsSUM_meters;

						outfile.close();

					}
					else
					{
						std::cout << "Unable to create output file:\n" << fulloutname << "\n";
					}

					fulloutname.erase(fulloutname.find("average_path_length_summary.txt"),std::string::npos);
					fulloutname.append("diameter_summary.txt");

					outfile.open(fulloutname);		//output diameter summary

					if (outfile.is_open())
					{

						outfile<< *diametersSUM_hops << " " << *diametersSUM_meters;

						outfile.close();

					}
					else
					{
						std::cout << "Unable to create output file:\n" << fulloutname << "\n";
					}

					fulloutname.erase(fulloutname.find("diameter_summary.txt"),std::string::npos);
					fulloutname.append("files.txt");

					outfile.open(fulloutname);		//output names of files used in summary

					if (outfile.is_open())
					{
						outfile << file_names;
						outfile.close();
					}
					else
					{
						std::cout << "Unable to create output file:\n" << fulloutname << "\n";
					}


				}//end if
				else if(matches == 0)
				{
					system("CLS");
					std::cout << "No matches for " << sequence << " found in any files of the directory:\n";
					std::cout << path;
					std::system("PAUSE");
					system("CLS");
				}
				else if (matches == 1)
				{
					system("CLS");
					std::cout << "Only 1 file was found matching " << sequence << " in the directory:\n";
					std::cout << path << "\n";
					system("PAUSE");
					system("CLS");
				}

			}//end if


			//delete pointers

			delete componentsSUM;
			componentsSUM = 0;

			delete neighboursSUM;
			neighboursSUM = 0;

			delete pathlengthsSUM_hops;
			pathlengthsSUM_hops = 0;

			delete pathlengthsSUM_meters;
			pathlengthsSUM_meters = 0;

			delete diametersSUM_hops;
			diametersSUM_hops = 0;

			delete diametersSUM_meters;
			diametersSUM_meters = 0;

			delete [] components;
			components = 0;

			delete [] neighbours;
			neighbours = 0;

			delete [] pathlengths;
			pathlengths = 0;

			delete [] diameters;
			diameters = 0;

		}
		else
		{
			system("CLS");
			std::cout << "\n\nThe file path is not valid\n\n";
			std::system("PAUSE");
			system("CLS");
		}

	}	//end if
	

	return 0;


}


 //------------------------------------------------------------------------------FUNCTIONS-------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


/*
	Static_NS2 function:
		Reads in static NS2 scenario and outputs statistics
*/
void Static_NS2(std::string path2)
{

	num_nodes = 0;

	system("CLS");

	//Create a typedef for the Graph, Vertex and Edge type
	typedef adjacency_list<vecS, vecS, undirectedS, no_property, property<edge_weight_t, double>> Graph;
	typedef graph_traits<Graph>::vertex_descriptor Vertex;
	typedef graph_traits <Graph>::vertex_descriptor vertex_descriptor;
	typedef std::pair<int, int> Edge;

	//Declare every variable	
	int i = 0, k = 0, m = 0, o = 0, n = 0, p = 0, count2 = 0, maxcount = 0, maxdist = 0, minhops = 1;
	
	double count1 = 0, l = 0, sum = 0, count3 = 0, sum2 = 0, averagelength = 0, sumofhops = 0, maxconnected = 0;
	
	int* maxcountarray = new int[100];
	int* mostnodeneigbors = new int[100];
	double* maxarray = new double[100];
	double* maxconnectedarray = new double[100];

	for (int i = 0;i < 100;i++)
	{
		maxcountarray[i] = 0;
		mostnodeneigbors[i] = 0;
		maxarray[i] = 0;
		maxconnectedarray[i] = 0;
	}

	std::string line;

	std::string fullinfilename = path2 + infilename;

	std::string fulloutfilename = path2 + outfilename;


	//Search through the file to see how many nodes the file has 
	std::ifstream myinfile (fullinfilename);

	if (myinfile.is_open())
	{
		myinfile.ignore(10);
		std::getline(myinfile,line);
		num_nodes = atoi(line.c_str());

		myinfile.close();
		myinfile.open(fullinfilename);

	}
	else
	{
		std::cout << "Unable to open file: " << infilename << "\n";
		system("PAUSE"); 
	}

	//Create arrays for the x y and z coordinates
	double* x = new double[num_nodes];
	std::fill_n(x,num_nodes,0);
	double* y = new double[num_nodes];
	std::fill_n(y,num_nodes,0);
	double* z = new double[num_nodes];
	std::fill_n(z,num_nodes,0);

	//Read through the file to find coordinates of each and every node
	if (myinfile.is_open())
	{

		std::cout << infilename << "\n";
		std::cout << "Beginning to read file...\n";

		while ( myinfile.good() )
		{

			std::getline(myinfile,line);
			if (line == "#") continue;

			for (i = 0; i < num_nodes; i++) 
			{
				if (i < 10) 
				{
					myinfile.ignore(18);
					myinfile >> x[i];
					myinfile.ignore(18);
					myinfile >> y[i];
					myinfile.ignore(18);
					myinfile >> z[i];
				} 
				else if (i >= 10)
				{
					myinfile.ignore(19);
					myinfile >> x[i];
					myinfile.ignore(19);
					myinfile >> y[i];
					myinfile.ignore(19);
					myinfile >> z[i];
				} 
				else if (i >= 100) 
				{ 
					myinfile.ignore(20);
					myinfile >> x[i];
					myinfile.ignore(20);
					myinfile >> y[i];
					myinfile.ignore(20);
					myinfile >> z[i];
				}

			}//end for

			break;

		}	//end while

		myinfile.close();

	} 
	else 
	{  
		std::cout << "Unable to open file: " << infilename << "\n";
		system("PAUSE"); 
	}

	std::cout << "Creating statistics...\n";

	//With every node's coordinates known, we must find how many edges this netwrok will have 
	// (and therefore know if the two nodes are connected)
	for(n = 0; n < num_nodes; n++) 
	{

		for (p = n+1; p < num_nodes; p++) 
		{
			
			//Use pythagorean theorum to find the edge distance (Change in x^2 + Change in y^2 = Hypothenuse^2)
			l = sqr(x[p] - x[n]) + sqr(y[p]-y[n]) + sqr(z[p]-z[n]);
			l = pow(l, 0.5);
			
			//If the edge distance is less than 250 metres, than the nodes are connected
			//If this is true, store how many edges are needed into variable m so that an array can be made 
			if (l <= transmissonrange) 
			{
				m++;
			}

		} //end for

	}//end for

	//Now create the edges and their weights
	double* weights = new double[m];
	std::fill_n(weights,m,0);

	Edge* edge_array = new Edge[max_amount];

	for(n = 0; n < num_nodes; n++) 
	{

		for (p = n+1; p < num_nodes; p++) 
		{
			
			//Use pythagorean theorum to find the edge distance (Change in x^2 + Change in y^2 = Hypothenuse^2)
			l = sqr(x[p] - x[n]) + sqr(y[p]-y[n]) + sqr(z[p]-z[n]);
			l = pow(l, 0.5);
			
			//If the edge distance is less than 250 metres, than the nodes are connected
			//If this is true, create an edge between the nodes and store the magnitude of the distance as the edge weight 
			if (l <= transmissonrange) 
			{
				edge_array[o] = Edge(n,p);
				o++;
				weights[k] = l;
				k++;
			}

		}//end for

	}//end for

	const int num_arcs = sizeof(*edge_array)/sizeof(edge_array[0]);


	// declare a graph object, adding the edges and edge properties
	
	#if defined(BOOST_MSVC) && BOOST_MSVC <= 1300
		// VC++ can't handle the iterator constructor
		Graph G(num_nodes);
		property_map<Graph, edge_weight_t>::type weightmap = get(edge_weight, G);
		for (std::size_t j = 0; j < num_edges; ++j) 
		{
			graph_traits<Graph>::edge_descriptor t; bool inserted;
			boost::tie(t, inserted) = add_edge(edge_array[j].first, edge_array[j].second, G);
			weightmap[t] = weights[j];
		}
	#else
		Graph G(edge_array, edge_array + o, weights, num_nodes);	//changed

	#endif

	//Removing edges 0-0 will remove all the blank edges of the array and will only keep the existing ones
	boost::remove_edge(0, 0, G);

	//Create a new array of edge weights of all 1s and make a new graph with this
	//This will help us calculate hops

	int* weights2 = new int[m];

	for (int f = 0; f < m; f++) 
	{
		weights2[f] = 1;
	}

	//New graph with edge weights of only 1, purely just for find number of hops
	Graph gt(edge_array, edge_array + o, weights2, num_nodes);
	boost::remove_edge (0,0,gt);

	//Use propety map to create a vertex index and an edge weight
	boost::property_map<Graph, vertex_index_t>::type vertex_id = get(vertex_index,G);
	boost::property_map<Graph, edge_weight_t>::type weightmap = get(edge_weight,G);

	typedef graph_traits<Graph>::vertex_iterator vertex_iter;
	std::pair<vertex_iter, vertex_iter> vp;

	graph_traits<Graph>::edge_iterator ei, ei_end;
	
	k = 0;
	
	//Make the program outout each Node and ever Node that is connected to it
	//While doing this, take note of the average amount of neighbors( connected nodes)
	//each node has and which node(s) has the most neighbors 
	for (vp = vertices(G); vp.first != vp.second; ++vp.first) 
	{
		boost::property_map<Graph, vertex_index_t>::type
		vertex_id = get(vertex_index, G);
		count1++;

		// For each node get the outgoing edges, but only output the target node and increase count2 by 1 for each
		boost::graph_traits<Graph>::out_edge_iterator out_i, out_end;
		boost::graph_traits<Graph>::edge_descriptor e;
		for (boost::tie(out_i, out_end) = out_edges(*vp.first, G);out_i != out_end; ++out_i)
		{
			e = *out_i;
			Vertex targ = target(e, G);
			count2++;
		}

		//If this node has more or same amount of nieghbors than the previous highest node,
		// save it's value in the maxcountarray and it's name in the mostnodeneighbors array 
		if (count2 >= maxcount) 
		{
			maxcount = count2;
			maxcountarray[k] = maxcount;
			mostnodeneigbors[k] = *vp.first;
			k++;
		}
		
		//Add up all the count2s and store them in the variable sum
		sum+= count2;
		count2 = 0;

	}//end for

	//Calculcate Shortest Paths
	std::vector<vertex_descriptor> P(num_vertices(G));
	std::vector<int> d(num_vertices(G));
   
	for (p=0; p < num_nodes; p++) 
	{
		vertex_descriptor s = vertex(p, G);

		#if defined(BOOST_MSVC) && BOOST_MSVC <= 1300
			// VC++ has trouble with the named parameters mechanism
			property_map<graph_t, vertex_index_t>::type indexmap = get(vertex_index, g);
			dijkstra_shortest_paths(g, s, &p[0], &d[0], weightmap, indexmap, 
							std::less<int>(), closed_plus<int>(), 
							(std::numeric_limits<int>::max)(), 0,
							default_dijkstra_visitor());
		#else
			dijkstra_shortest_paths(G, s, predecessor_map(&P[0]).distance_map(&d[0]));
		#endif
	
		graph_traits <Graph>::vertex_iterator vi, vend;
		for (boost::tie(vi, vend) = vertices(G); vi != vend; ++vi) 
		{
			if (d[*vi] >= maxdist) 
			{
				maxdist = d[*vi];
			}
			sum2+= d[*vi];	
			count3++;

		}//end for

	}//end for

	//Calculcate Shortest Paths for the graph with edge weights all = to 1
	//This will help us calculate the distance in of hops (hops = distance)
	std::vector<vertex_descriptor> PM(num_vertices(gt));
	std::vector<int> D(num_vertices(gt));

	for (p=0; p < num_nodes; p++) 
	{

		vertex_descriptor s = vertex(p, gt);

		#if defined(BOOST_MSVC) && BOOST_MSVC <= 1300
			// VC++ has trouble with the named parameters mechanism
			property_map<graph_t, vertex_index_t>::type indexmap = get(vertex_index, g);
			dijkstra_shortest_paths(g, s, &p[0], &d[0], weightmap, indexmap, 
							std::less<int>(), closed_plus<int>(), 
							(std::numeric_limits<int>::max)(), 0,
							default_dijkstra_visitor());
		#else
			dijkstra_shortest_paths(gt, s, predecessor_map(&PM[0]).distance_map(&D[0]));
		#endif
	
		graph_traits <Graph>::vertex_iterator vi, vend;
		for (boost::tie(vi, vend) = vertices(G); vi != vend; ++vi) 
		{
			if (D[*vi] >= minhops) 
			{
				minhops = D[*vi];
			}
			sumofhops = sumofhops + D[*vi];

		}//end for

	}//end for

	//Calculate the connected components of the network
	std::vector<int> component(num_vertices(G));
	int num = connected_components(G, &component[0]);

	//Find the Betweeness Centrality of the network
	typedef graph_traits<Graph>::vertex_iterator Vertex_Iter; Vertex_Iter vertex_iterator_begin, vertex_iterator_end; std::vector<double> centrality(num_nodes); 
         
	boost::brandes_betweenness_centrality(G, centrality_map(make_iterator_property_map(centrality.begin(), get(vertex_index, G),double())).vertex_index_map(get(vertex_index, G))); 
    
	o = 0;

	for ( tie(vertex_iterator_begin, vertex_iterator_end) = vertices(G); vertex_iterator_begin != vertex_iterator_end; ++vertex_iterator_begin) 
	{	
		if (centrality[*vertex_iterator_begin] >= maxconnected) 
		{
			maxconnected = centrality[*vertex_iterator_begin];
			maxarray[o] = centrality[*vertex_iterator_begin];
			maxconnectedarray[o] = *vertex_iterator_begin;
			o++;
		}

	}//end for	

	count3 = (num_nodes - 1)*(num_nodes);
	averagelength = sum2/count3;

	int* mostneighbours = new int[100];
	std::fill_n(mostneighbours,100,0);

	if (k >= 1)
	{
		mostneighbours[0] = mostnodeneigbors[k - 1];
	}
	else
		std::cout << "!!";

	int u = 1;

	for (int n = k - 2; n >= 0; n--) 
	{

		if (maxcountarray[n] == maxcountarray[n+1]) 
		{

			//std::cout << mostnodeneigbors[n] << " ";

			int s = mostnodeneigbors[n];

			mostneighbours[u] = mostnodeneigbors[n];

			u++;

		}	//end if

	}	//end for

	double* centralnodes = new double[num_nodes];
	std::fill_n(centralnodes,num_nodes,0.0);

	if (o >= 1)
	{
		centralnodes[0] = maxconnectedarray[o-1];
	}
	else
		std::cout << "!!";

	int w = 1;

	for (int n = o - 2; n >= 0; n--) 
	{

		if (maxarray[n] == maxarray[n+1]) 
		{

			//std::cout << maxconnectedarray[n] << " ";

			centralnodes[w] = maxconnectedarray[n];

			w++;

		} 
		else 
		{
			break;
		}	//end if

	}	//end for
	
	std::cout <<"Creating output files...\n";

	//If the user answered Yes for the visualization, output the GraphViz code for them
	if (visualization == true) 
	{
		myoutfile.open(fulloutfilename);
		if (myoutfile.is_open())
		{
			myoutfile << "Graph G {" << std::endl;
			for (int q = 0; q < num_nodes; q++) 
			{
				myoutfile << q << " [pos=" << " \"" << x[q] << "," << y[q] << "!\"];" << std::endl;
			}
			for (boost::tie(ei, ei_end) = edges(G); ei != ei_end; ++ei) 
			{
				myoutfile << source(*ei, G) << "--" << target(*ei,G) <<";" << std::endl;
			}
			myoutfile << "}";

			myoutfile.close();
					
		}
		else
		{
			system("CLS");
			std::cout << "Unable to make graphViz visualization:\n";
			std::cout << outfilename << "\n";
			std::system("PAUSE");
			system("CLS");
		}

		fulloutfilename.erase(fulloutfilename.find("graphViz"),std::string::npos);

	}//end if


	fulloutfilename.append("average_neighbours.txt");		//average neighbours
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		myoutfile << sum/count1;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make average neighbours file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("average_neighbours.txt"),std::string::npos);	//most neighbours
	fulloutfilename.append("most_neighbours.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		for (int f = 0; f < u; f++) 
		{
			myoutfile << mostneighbours[f] << " ";	
		}
		if (k >= 1)
		{
			myoutfile << " (" << maxcountarray[k-1] << ")";
		}
		else
		{
			system("CLS");
			std::cout << "Error creating most neighbours file:\n";
			std::cout << outfilename << "\n";
			std::system("PAUSE");
			system("CLS");
		}

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make most neighbours file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("most_neighbours.txt"),std::string::npos);		//average path length
	fulloutfilename.append("average_path_length.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		myoutfile << sumofhops/count3 << " " << averagelength;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make average path length file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("average_path_length.txt"),std::string::npos);		//diameter
	fulloutfilename.append("diameter.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{	
		myoutfile << minhops << " " << maxdist;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make diameter file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("diameter.txt"),std::string::npos);	//components
	fulloutfilename.append("components.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		myoutfile << num;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make components file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("components.txt"),std::string::npos);	//node centrality
	fulloutfilename.append("node_centrality.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		for (int i = 0; i < w; i++) 
		{

			myoutfile << centralnodes[i] << " ";

		} //end for
		
		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make node centrality file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}

	std::cout << "Statistics were successfully created for: " << infilename << "\n";

	

	delete [] mostneighbours;
	mostneighbours = 0;

	delete [] centralnodes;
	centralnodes = 0;

	delete [] weights;
	weights = 0;

	delete [] weights2;
	weights2 = 0;

	delete [] maxconnectedarray;
	maxconnectedarray = 0;

	delete [] maxarray;
	maxarray = 0;

	delete [] mostnodeneigbors;
	mostnodeneigbors = 0;

	delete [] maxcountarray;
	maxcountarray = 0;

	delete [] edge_array;
	edge_array = 0;

	delete [] x;
	x = 0;

	delete [] y;
	y = 0;

	delete [] z;
	z = 0;

}


/*
	Static_OPNET function:
		Reads in static OPNET scenario and outputs statistics
*/
void Static_OPNET(std::string path2)		//test
{

	//Create a typedef for the Graph, Vertex and Edge type
	typedef adjacency_list<vecS, vecS, undirectedS, no_property, property<edge_weight_t, double>> Graph;
	typedef graph_traits<Graph>::vertex_descriptor Vertex;
	typedef graph_traits <Graph>::vertex_descriptor vertex_descriptor;
	typedef std::pair<int, int> Edge;

	//Declare every variable
	int i = 0, k = 0, m = 0, o = 0, n = 0, p = 0, j = 0, count2 = 0, maxcount = 0, maxcountarray[10], maxdist = 0, mostnodeneigbors[10], minhops = 1;
	
	double count1 = 0, l = 0, sum = 0, count3 = 0, sum2 = 0, maxconnected = 0, sumofhops = 0, maxarray[10], maxconnectedarray[10], averagelength = 0;
	
	std::string line;

	std::string fullinfilename = path2 + infilename;

	std::string fulloutfilename = path2 + outfilename;

	std::string::size_type w;

	for (int i = 0;i < 10;i++)
	{
		maxcountarray[i] = 0;
		mostnodeneigbors[i] = 0;
		maxarray[i] = 0;
		maxconnectedarray[i] = 0;
	}

	//Read through the input file to find how many nodes the network has. 
	std::ifstream myinfile (fullinfilename);

	while (myinfile.good()) 
	{
		getline (myinfile, line);
		if (line == "			</ext-attr>") 
		{
			num_nodes++;
		}
	}

	myinfile.close();
	num_nodes = num_nodes/2;
	myinfile.open(fullinfilename);

	//Create 3 arrays for the x y and z coordinates of each node
	double* x = new double[num_nodes];
	double* y = new double[num_nodes];
	double* z = new double[num_nodes];


	//Read through the input file for the coordinates of each node
	if (myinfile.is_open())
	{
		while ( myinfile.good() )
		{
			getline (myinfile, line);
			if (line == "			</ext-attr>") 
			{	
				for (i = 0; i < 1; i++) 
				{
					myinfile.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
					getline (myinfile, line);
				}

				myinfile.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
				myinfile.ignore(34);
				getline (myinfile, line);
				myinfile.ignore(34);
				w = line.find(",", 0);

				if (w != std::string::npos) 
				{
					line.erase(w,1);
					x[j] = atoi(line.c_str());
				} 
				else 
				{
					x[j] = atoi(line.c_str());
				}

				getline (myinfile, line);
				w = line.find(",", 0);

				if (w != std::string::npos) 
				{
					line.erase(w,1);
					y[j] = atoi(line.c_str());
				}
				else 
				{
					y[j] = atoi(line.c_str());
				}

				j++;
				continue;

			}
			else 
			{
				continue;
			}

		}//end while

	} 
	else 
	{ 
		std::cout << "Unable to open file";
		system("PAUSE"); 
	}
	
	//With every node's coordinates known, we must find how many edges this netwrok will have 
	// (and therefore know if the two nodes are connected)
	for(n = 0; n < num_nodes; n++) 
	{

		for (p = n+1; p < num_nodes; p++) 
		{
			
			//Use pythagorean theorum to find the edge distance (Change in x^2 + Change in y^2 = Hypothenuse^2)
			l = sqr(x[p] - x[n]) + sqr(y[p]-y[n]);
			l = pow(l, 0.5);
			
			//If the edge distance is less than 1000 metres, than the nodes are connected
			//If this is true, store how many edges are needed into variable m so that an array can be made 
			if (l <= transmissonrange) 
			{
				m++;
			}

		} //end for

	}//end for

	//Now create the edges and their weights
	double* weights = new double[m];
	Edge edge_array[999];
	
	for(n = 0; n < num_nodes; n++) 
	{

		for (p = n+1; p < num_nodes; p++) 
		{
			
			//Use pythagorean theorum to find the edge distance (Change in x^2 + Change in y^2 = Hypothenuse^2)
			l = sqr(x[p] - x[n]) + sqr(y[p]-y[n]) + sqr(z[p]-z[n]);
			l = pow(l, 0.5);
			
			//If the edge distance is less than 1000 metres, than the nodes are connected
			//If this is true, create an edge between the nodes and store the magnitude of the distance as the edge weight 
			if (l <= transmissonrange) 
			{
				edge_array[o] = Edge(n,p);
				o++;
				weights[k] = l;
				k++;
			}

		}//end for

	}//end for

	const int num_arcs = sizeof(edge_array)/sizeof(edge_array[0]);


	// declare a graph object, adding the edges and edge properties
	
	#if defined(BOOST_MSVC) && BOOST_MSVC <= 1300
		// VC++ can't handle the iterator constructor
		Graph G(num_nodes);
		property_map<Graph, edge_weight_t>::type weightmap = get(edge_weight, G);
		for (std::size_t j = 0; j < num_edges; ++j) 
		{
			graph_traits<Graph>::edge_descriptor t; bool inserted;
			boost::tie(t, inserted) = add_edge(edge_array[j].first, edge_array[j].second, G);
			weightmap[t] = weights[j];
		}
	#else
		Graph G(edge_array, edge_array + o, weights, num_nodes);
	#endif

	//Removing edges 0-0 will remove all the blank edges of the array and will only keep the existing ones
	boost::remove_edge(0, 0, G);

	//Create a new array of edge weights of all 1s and make a new graph with this
	//This will help us calculate hops
	int* weights2 = new int[o];
	for (int f = 0; f < o; f++) 
	{
		weights2[f] = 1;
	}

	//New graph with edge weights of only 1, purely just for find number of hops
	Graph gt(edge_array, edge_array + o, weights2, num_nodes);
	boost::remove_edge (0,0,gt);

	//Use propety map to create a vertex index and an edge weight
	boost::property_map<Graph, vertex_index_t>::type vertex_id = get(vertex_index,G);

	boost::property_map<Graph, edge_weight_t>::type weightmap = get(edge_weight,G);

	typedef graph_traits<Graph>::vertex_iterator vertex_iter; std::pair<vertex_iter, vertex_iter> vp; graph_traits<Graph>::edge_iterator ei, ei_end; 
	
	k = 0;
	
	//Make the program outout each Node and ever Node that is connected to it
	//While doing this, take note of the average amount of neighbors( connected nodes)
	//each node has and which node(s) has the most neighbors 
	for (vp = vertices(G); vp.first != vp.second; ++vp.first) 
	{
		boost::property_map<Graph, vertex_index_t>::type
		vertex_id = get(vertex_index, G);
		count1++;

		// For each node get the outgoing edges, but only output the target node and increase count2 by 1 for each
		boost::graph_traits<Graph>::out_edge_iterator out_i, out_end;
		boost::graph_traits<Graph>::edge_descriptor e;

		for (boost::tie(out_i, out_end) = out_edges(*vp.first, G);out_i != out_end; ++out_i)
		{
			e = *out_i;
			Vertex targ = target(e, G);
			count2++;
		}

		//If this node has more or same amount of nieghbors than the previous highest node,
		// save it's value in the maxcountarray and it's name in the mostnodeneighbors array 
		if (count2 >= maxcount) 
		{
			maxcount = count2;
			maxcountarray[k] = maxcount;
			mostnodeneigbors[k] = *vp.first;
			k++;
		}
	
		//Add up all the count2s and store them in the variable sum
		sum+= count2;
		count2 = 0;

	}//end for

	//Calculcate Shortest Paths
	std::vector<vertex_descriptor> P(num_vertices(G));
	std::vector<int> d(num_vertices(G));
   
	for (p=0; p < num_nodes; p++) 
	{

		vertex_descriptor s = vertex(p, G);

		#if defined(BOOST_MSVC) && BOOST_MSVC <= 1300
			// VC++ has trouble with the named parameters mechanism
			property_map<graph_t, vertex_index_t>::type indexmap = get(vertex_index, g);
			dijkstra_shortest_paths(g, s, &p[0], &d[0], weightmap, indexmap, 
						std::less<int>(), closed_plus<int>(), 
						(std::numeric_limits<int>::max)(), 0,
						default_dijkstra_visitor());
		#else
			dijkstra_shortest_paths(G, s, predecessor_map(&P[0]).distance_map(&d[0]));
		#endif

		graph_traits <Graph>::vertex_iterator vi, vend;
		for (boost::tie(vi, vend) = vertices(G); vi != vend; ++vi) 
		{

			if (d[*vi] >= maxdist) 
			{
				maxdist = d[*vi];
			}
			sum2+= d[*vi];

		}//end for

	}//end for

	//Calculcate Shortest Paths for the graph with edge weights all = to 1
	//This will help us calculate the total number of hops (hops = distance)
	std::vector<vertex_descriptor> PM(num_vertices(gt));
	std::vector<int> D(num_vertices(gt));
   
	for (p=0; p < num_nodes; p++) 
	{

		vertex_descriptor s = vertex(p, gt);

		#if defined(BOOST_MSVC) && BOOST_MSVC <= 1300
			// VC++ has trouble with the named parameters mechanism
			property_map<graph_t, vertex_index_t>::type indexmap = get(vertex_index, g);
			dijkstra_shortest_paths(g, s, &p[0], &d[0], weightmap, indexmap, 
						std::less<int>(), closed_plus<int>(), 
						(std::numeric_limits<int>::max)(), 0,
						default_dijkstra_visitor());
		#else
			dijkstra_shortest_paths(gt, s, predecessor_map(&PM[0]).distance_map(&D[0]));
		#endif
	
		graph_traits <Graph>::vertex_iterator vi, vend;
		for (boost::tie(vi, vend) = vertices(G); vi != vend; ++vi) 
		{

			if (D[*vi] >= minhops) 
			{
				minhops = D[*vi];
			}
			sumofhops = sumofhops + D[*vi];

		}//end for

	}//end for

	//Calculate the connected components of the network
	std::vector<int> component(num_vertices(G));
	int num = connected_components(G, &component[0]);

	//Find the Betweeness Centrality of the network
	typedef graph_traits<Graph>::vertex_iterator Vertex_Iter; 
	Vertex_Iter vertex_iterator_begin, vertex_iterator_end; 
	std::vector<double> centrality(num_nodes); 
         
	boost::brandes_betweenness_centrality(G,centrality_map(make_iterator_property_map(centrality.begin(), get(vertex_index, G),double())).vertex_index_map(get(vertex_index, G))); 
    
	o = 0;

	for ( tie(vertex_iterator_begin, vertex_iterator_end) = vertices(G); vertex_iterator_begin != vertex_iterator_end; ++vertex_iterator_begin) 
	{	
		if (centrality[*vertex_iterator_begin] >= maxconnected) 
		{
			maxconnected = centrality[*vertex_iterator_begin];
			maxarray[o] = centrality[*vertex_iterator_begin];
			maxconnectedarray[o] = *vertex_iterator_begin;
			o++;
		}
	}	

	count3 = (num_nodes - 1)*(num_nodes);
	averagelength = sum2/count3;
	
	int* mostneighbours = new int[100];
	std::fill_n(mostneighbours,100,0);

	if (k >= 1)
	{
		mostneighbours[0] = mostnodeneigbors[k - 1];
	}
	else
		std::cout << "!!";

	int u = 1;

	for (int n = k - 2; n >= 0; n--) 
	{

		if (maxcountarray[n] == maxcountarray[n+1]) 
		{

			//std::cout << mostnodeneigbors[n] << " ";

			int s = mostnodeneigbors[n];

			mostneighbours[u] = mostnodeneigbors[n];

			u++;

		}	//end if

	}	//end for

	double* centralnodes = new double[num_nodes];
	std::fill_n(centralnodes,num_nodes,0.0);

	if (o >= 1)
	{
		centralnodes[0] = maxconnectedarray[o-1];
	}
	else
		std::cout << "!!";

	int ww = 1;

	for (int n = o - 2; n >= 0; n--) 
	{

		if (maxarray[n] == maxarray[n+1]) 
		{

			//std::cout << maxconnectedarray[n] << " ";

			centralnodes[ww] = maxconnectedarray[n];

			ww++;

		} 
		else 
		{
			break;
		}	//end if

	}	//end for

	std::cout <<"Creating output files...\n";

	//If the user answered Yes for the visualization, output the GraphViz code for them
	if (visualization == true) 
	{
		myoutfile.open(fulloutfilename);
		if (myoutfile.is_open())
		{
			myoutfile << "Graph G {" << std::endl;
			for (int q = 0; q < num_nodes; q++) 
			{
				myoutfile << q << " [pos=" << " \"" << x[q] << "," << y[q] << "!\"];" << std::endl;
			}
			for (boost::tie(ei, ei_end) = edges(G); ei != ei_end; ++ei) 
			{
				myoutfile << source(*ei, G) << "--" << target(*ei,G) <<";" << std::endl;
			}
			myoutfile << "}";

			myoutfile.close();
					
		}
		else
		{
			system("CLS");
			std::cout << "Unable to make graphViz visualization:\n";
			std::cout << outfilename << "\n";
			std::system("PAUSE");
			system("CLS");
		}

		fulloutfilename.erase(fulloutfilename.find("graphViz"),std::string::npos);

	}//end if


	fulloutfilename.append("average_neighbours.txt");		//average neighbours
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		myoutfile << sum/count1;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make average neighbours file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("average_neighbours.txt"),std::string::npos);	//most neighbours
	fulloutfilename.append("most_neighbours.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		for (int f = 0; f < u; f++) 
		{
			myoutfile << mostneighbours[f] << " ";	
		}
		if (k >= 1)
		{
			myoutfile << " (" << maxcountarray[k-1] << ")";
		}
		else
		{
			system("CLS");
			std::cout << "Error creating most neighbours file:\n";
			std::cout << outfilename << "\n";
			std::system("PAUSE");
			system("CLS");
		}

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make most neighbours file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("most_neighbours.txt"),std::string::npos);		//average path length
	fulloutfilename.append("average_path_length.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		myoutfile << sumofhops/count3 << " " << averagelength;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make average path length file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("average_path_length.txt"),std::string::npos);		//diameter
	fulloutfilename.append("diameter.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{	
		myoutfile << minhops << " " << maxdist;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make diameter file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("diameter.txt"),std::string::npos);	//components
	fulloutfilename.append("components.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		myoutfile << num;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make components file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("components.txt"),std::string::npos);	//node centrality
	fulloutfilename.append("node_centrality.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		for (int i = 0; i < ww; i++) 
		{

			myoutfile << centralnodes[i] << " ";

		} //end for
		
		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make node centrality file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}

	std::cout << "Statistics were successfully created for: " << infilename << "\n";

	

	delete [] mostneighbours;
	mostneighbours = 0;

	delete [] centralnodes;
	centralnodes = 0;

	delete [] weights;
	weights = 0;

	delete [] weights2;
	weights2 = 0;

	delete [] x;
	x = 0;

	delete [] y;
	y = 0;

	delete [] z;
	z = 0;


}


/*
	Static_CORE function:
		Reads in static CORE scenario and outputs statistics
*/
void Static_CORE(std::string path2)		//test
{

	//Create a typedef for the Graph, Vertex and Edge type
	typedef adjacency_list<vecS, vecS, undirectedS, no_property, property<edge_weight_t, double>> Graph;
	typedef graph_traits<Graph>::vertex_descriptor Vertex;
	typedef graph_traits <Graph>::vertex_descriptor vertex_descriptor;
	typedef std::pair<int, int> Edge;

	//Declare every variable
	
	int i = 0, k = 0, m = 0, o = 0, n = 0, p = 0, count2 = 0, j = 0, maxcount = 0, maxcountarray[10], maxdist = 0, mostnodeneigbors[10], minhops = 1, s = 0, v = 0, t = 49, WLAN1[999], sumofs = 0, sumofv = 0, numofhops = 0;
	
	double count1 = 0, l = 0, sum = 0, count3 = 0, sum2 = 0, maxconnected = 0, maxarray[10], maxconnectedarray[10], sumofhops = 0, averagelength = 0;
	
	int* edgeweights = new int[max_amount];

	std::string line;

	std::string fullinfilename = path2 + infilename;

	std::string fulloutfilename = path2 + outfilename;

	for (int i = 0;i < 10;i++)
	{
		maxcountarray[i] = 0;
		mostnodeneigbors[i] = 0;
		maxarray[i] = 0;
		maxconnectedarray[i] = 0;
	}

	Edge edge_array[999];

	//Read through the file to see how many nodes there are

	std::ifstream myinfile (fullinfilename);

	while(myinfile.good()) 
	{
		getline (myinfile, line);
		if (line == "    type router") 
		{
			num_nodes++;
		}
	}

	myinfile.close();

	//Create arrays for the x y and z coordinates of each nodes
  	double* x = new double[num_nodes];
	std::fill_n(x,num_nodes,0);
	double* y = new double[num_nodes];
	std::fill_n(y,num_nodes,0);
	double* z = new double[num_nodes];
	std::fill_n(z,num_nodes,0);
	double* nodes = new double[num_nodes*2];
	std::fill_n(nodes,num_nodes,0);

	myinfile.open(fullinfilename);

	//Read through the file to find the coordinates of each node
	if (myinfile.is_open())
	{

		while ( myinfile.good() )
		{

			getline (myinfile, line);

			if (line == "    type router") 
			{
				while (line != "    }") 
				{
					getline (myinfile, line); 
				}

				getline (myinfile, line);
				line.erase(0,16);
				//Once we get to the coordinates, we need to seperate the x and the y coordinates with a tokenizer
				//Store both coordinates in a single array nodes[], but we'll seperate them later
				char_separator<char> sep(" ");
				tokenizer< char_separator<char> > tokens(line, sep);
				BOOST_FOREACH (const std::string& t, tokens) 
				{
					nodes[j] = atoi(t.c_str());
					j++;
				}

			}//end if

		}//end while

		//Incase the file doesn't open, close the program
	} 
	else 
	{
		std::cout << "Unable to open file";
  		system("PAUSE");
	}
  
	i = 0;

	//Now seperate the nodes[] array into two seperate x and y arrays
	//The x coordinates are all stored in the even numbers of the nodes[] array, starting from 0
	for (j = 0; j < num_nodes*2; j+=2) 
	{
		x[i] = nodes[j];
		//std::cout << x[i];
		i++;
	}

	i = 0;
  
	//The y coordinates are all stored in the odd numbers of the nodes[] array, starting from 1
	for (j = 1; j < num_nodes*2; j+=2) 
	{
		y[i] = nodes[j];
		//std::cout << y[i];
		i++;
	}

	//Now that we know the position of each node, we need to find out which nodes are connected to each other
	//In Core a node is connected to another node if they are both linked to the same WLAN
	//Therefore we must go through the file again, look for which nodes are linked to which WLANs, store them in array called WLAN1
	//and then make edges for each element in the array
	std::ifstream myinfile2 (fullinfilename);

	if (myinfile2.is_open())
	{

		while ( myinfile2.good() ) 
		{

			getline (myinfile2, line);

			if (line == "    type wlan") 
			{

				while (line != "    canvas c1") 
				{
					getline (myinfile2, line);
				}

				getline (myinfile2, line);
				getline (myinfile2, line);

				for (;;) 
				{
					myinfile2.ignore(24);
					getline (myinfile2, line);
					if (atoi(line.c_str()) != 0) {
						WLAN1[s] = atoi(line.c_str());
						s++;
					}
					else
					{
						break;
					}

				}//end for

				for (n = 0; n < s; n++) 
				{
						
					for (p = n+1; p < s; p++) 
					{
						l = sqr(x[WLAN1[p] - 1] - x[WLAN1[n] - 1]) + sqr(y[WLAN1[p] - 1]-y[WLAN1[n] - 1]);
						l = pow(l, 0.5);
						edge_array[o] = Edge(WLAN1[n] - 1,WLAN1[p] - 1);
						o++;
						edgeweights[k] = int ( l );
						k++;

					}//end for

				}//end for		

				s = 0;
				numofhops++;

			}//end if

		}//end while

	}//end if

	const int num_arcs = sizeof(edge_array)/sizeof(edge_array[0]);

	// declare a graph object, adding the edges and edge properties
	
	#if defined(BOOST_MSVC) && BOOST_MSVC <= 1300
		// VC++ can't handle the iterator constructor
		Graph G(num_nodes);
		property_map<Graph, edge_weight_t>::type weightmap = get(edge_weight, G);
		for (std::size_t j = 0; j < num_edges; ++j) 
		{
			graph_traits<Graph>::edge_descriptor t; bool inserted;
			boost::tie(t, inserted) = add_edge(edge_array[j].first, edge_array[j].second, G);
			weightmap[t] = weights[j];
		}
	#else
		Graph G(edge_array, edge_array + o, edgeweights, num_nodes);
	#endif

	//Removing edges 0-0 will remove all the blank edges of the array and will only keep the existing ones
	boost::remove_edge(0, 0, G);

	//Create a new array of edge weights of all 1s and make a new graph with this
	//This will help us calculate hops
	int* weights2 = new int[o];
	for (int f = 0; f < o; f++) 
	{
		weights2[f] = 1;
	}

	//New graph with edge weights of only 1, purely just for find number of hops
	Graph gt(edge_array, edge_array + o, weights2, num_nodes);
	boost::remove_edge (0,0,gt);
		
	//Use propety map to create a vertex index and an edge weight
	boost::property_map<Graph, vertex_index_t>::type vertex_id = get(vertex_index,G);

	boost::property_map<Graph, edge_weight_t>::type weightmap = get(edge_weight,G);

	typedef graph_traits<Graph>::vertex_iterator vertex_iter;
	std::pair<vertex_iter, vertex_iter> vp;

	graph_traits<Graph>::edge_iterator ei, ei_end;
	
	k = 0;
	t = 1;

	//Make the program outout each Node and ever Node that is connected to it
	//While doing this, take note of the average amount of neighbors( connected nodes)
	//each node has and which node(s) has the most neighbors 
	for (vp = vertices(G); vp.first != vp.second; ++vp.first) 
	{
		boost::property_map<Graph, vertex_index_t>::type
		vertex_id = get(vertex_index, G);
		count1++;

		// For each node get the outgoing edges, but only output the target node and increase count2 by 1 for each
		boost::graph_traits<Graph>::out_edge_iterator out_i, out_end;
		boost::graph_traits<Graph>::edge_descriptor e;
		for (boost::tie(out_i, out_end) = out_edges(*vp.first, G);out_i != out_end; ++out_i)
		{
			count2++;
		}

		//If this node has more or same amount of nieghbors than the previous highest node,
		// save it's value in the maxcountarray and it's name in the mostnodeneighbors array 
		if (count2 >= maxcount) 
		{
			maxcount = count2;
			maxcountarray[k] = maxcount;
			mostnodeneigbors[k] = *vp.first;
			k++;
		}
	
		//Add up all the count2s and store them in the variable sum
		sum+= count2;
		count2 = 0;

	}//end for

	//Calculcate Shortest Paths
	std::vector<vertex_descriptor> P(num_vertices(G));
	std::vector<int> d(num_vertices(G));
   
	for (p=0; p < num_nodes; p++) 
	{

		vertex_descriptor s = vertex(p, G);

		#if defined(BOOST_MSVC) && BOOST_MSVC <= 1300
			// VC++ has trouble with the named parameters mechanism
			property_map<graph_t, vertex_index_t>::type indexmap = get(vertex_index, g);
			dijkstra_shortest_paths(g, s, &p[0], &d[0], weightmap, indexmap, 
						std::less<int>(), closed_plus<int>(), 
						(std::numeric_limits<int>::max)(), 0,
						default_dijkstra_visitor());
		#else
			dijkstra_shortest_paths(G, s, predecessor_map(&P[0]).distance_map(&d[0]));
		#endif
	
		graph_traits <Graph>::vertex_iterator vi, vend;
		for (boost::tie(vi, vend) = vertices(G); vi != vend; ++vi) 
		{
			if (d[*vi] >= maxdist) 
			{
				maxdist = d[*vi];
			}
			sum2+= d[*vi];

		}//end for

	}//end for

	//Calculcate Shortest Paths for the graph with edge weights all = to 1
	//This will help us calculate the total number of hops (hops = distance)
	std::vector<vertex_descriptor> PM(num_vertices(gt));
	std::vector<int> D(num_vertices(gt));
   
	for (p=0; p < num_nodes; p++) 
	{

		vertex_descriptor s = vertex(p, gt);

		#if defined(BOOST_MSVC) && BOOST_MSVC <= 1300
			// VC++ has trouble with the named parameters mechanism
			property_map<graph_t, vertex_index_t>::type indexmap = get(vertex_index, g);
			dijkstra_shortest_paths(g, s, &p[0], &d[0], weightmap, indexmap, 
						std::less<int>(), closed_plus<int>(), 
						(std::numeric_limits<int>::max)(), 0,
						default_dijkstra_visitor());
		#else
			dijkstra_shortest_paths(gt, s, predecessor_map(&PM[0]).distance_map(&D[0]));
		#endif
	
		graph_traits <Graph>::vertex_iterator vi, vend;
		for (boost::tie(vi, vend) = vertices(gt); vi != vend; ++vi) 
		{
			if (D[*vi] >= minhops)
			{
				minhops = D[*vi];
			}
			sumofhops = sumofhops + D[*vi];
					
		}//end for

	}//end for

	//Calculate the connected components of the network
	std::vector<int> component(num_vertices(G));
	int num = connected_components(G, &component[0]);

	//Find the Betweeness Centrality of the network
	typedef graph_traits<Graph>::vertex_iterator Vertex_Iter; 
	Vertex_Iter vertex_iterator_begin, vertex_iterator_end; 
	std::vector<double> centrality(num_nodes); 
         
	boost::brandes_betweenness_centrality(G, centrality_map(make_iterator_property_map(centrality.begin(), get(vertex_index, G),double())).vertex_index_map(get(vertex_index, G))); 
    
	o = 0;

	for ( tie(vertex_iterator_begin, vertex_iterator_end) = vertices(G); vertex_iterator_begin != vertex_iterator_end; ++vertex_iterator_begin) 
	{	
		if (centrality[*vertex_iterator_begin] >= maxconnected) 
		{
			maxconnected = centrality[*vertex_iterator_begin];
			maxarray[o] = centrality[*vertex_iterator_begin];
			maxconnectedarray[o] = *vertex_iterator_begin;
			o++;
		}
	}	

	count3 = (num_nodes - 1)*(num_nodes);
	averagelength = sum2/count3;
	
	int* mostneighbours = new int[100];
	std::fill_n(mostneighbours,100,0);

	if (k >= 1)
	{
		mostneighbours[0] = mostnodeneigbors[k - 1];
	}
	else
		std::cout << "!!";

	int u = 1;

	for (int n = k - 2; n >= 0; n--) 
	{

		if (maxcountarray[n] == maxcountarray[n+1]) 
		{

			//std::cout << mostnodeneigbors[n] << " ";

			int s = mostnodeneigbors[n];

			mostneighbours[u] = mostnodeneigbors[n];

			u++;

		}	//end if

	}	//end for

	double* centralnodes = new double[num_nodes];
	std::fill_n(centralnodes,num_nodes,0.0);

	if (o >= 1)
	{
		centralnodes[0] = maxconnectedarray[o-1];
	}
	else
		std::cout << "!!";

	int w = 1;

	for (int n = o - 2; n >= 0; n--) 
	{

		if (maxarray[n] == maxarray[n+1]) 
		{

			//std::cout << maxconnectedarray[n] << " ";

			centralnodes[w] = maxconnectedarray[n];

			w++;

		} 
		else 
		{
			break;
		}	//end if

	}	//end for

	std::cout <<"Creating output files...\n";

	//If the user answered Yes for the visualization, output the GraphViz code for them
	if (visualization == true) 
	{
		myoutfile.open(fulloutfilename);
		if (myoutfile.is_open())
		{
			myoutfile << "Graph G {" << std::endl;
			for (int q = 0; q < num_nodes; q++) 
			{
				myoutfile << q << " [pos=" << " \"" << x[q] << "," << y[q] << "!\"];" << std::endl;
			}
			for (boost::tie(ei, ei_end) = edges(G); ei != ei_end; ++ei) 
			{
				myoutfile << source(*ei, G) << "--" << target(*ei,G) <<";" << std::endl;
			}
			myoutfile << "}";

			myoutfile.close();
					
		}
		else
		{
			system("CLS");
			std::cout << "Unable to make graphViz visualization:\n";
			std::cout << outfilename << "\n";
			std::system("PAUSE");
			system("CLS");
		}

		fulloutfilename.erase(fulloutfilename.find("graphViz"),std::string::npos);

	}//end if


	fulloutfilename.append("average_neighbours.txt");		//average neighbours
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		myoutfile << sum/count1;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make average neighbours file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("average_neighbours.txt"),std::string::npos);	//most neighbours
	fulloutfilename.append("most_neighbours.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		for (int f = 0; f < u; f++) 
		{
			myoutfile << mostneighbours[f] << " ";	
		}
		if (k >= 1)
		{
			myoutfile << " (" << maxcountarray[k-1] << ")";
		}
		else
		{
			system("CLS");
			std::cout << "Error creating most neighbours file:\n";
			std::cout << outfilename << "\n";
			std::system("PAUSE");
			system("CLS");
		}

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make most neighbours file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("most_neighbours.txt"),std::string::npos);		//average path length
	fulloutfilename.append("average_path_length.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		myoutfile << sumofhops/count3 << " " << averagelength;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make average path length file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("average_path_length.txt"),std::string::npos);		//diameter
	fulloutfilename.append("diameter.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{	
		myoutfile << minhops << " " << maxdist;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make diameter file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("diameter.txt"),std::string::npos);	//components
	fulloutfilename.append("components.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		myoutfile << num;

		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make components file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}


	fulloutfilename.erase(fulloutfilename.find("components.txt"),std::string::npos);	//node centrality
	fulloutfilename.append("node_centrality.txt");
	myoutfile.open(fulloutfilename);
	if (myoutfile.is_open())
	{
		for (int i = 0; i < w; i++) 
		{

			myoutfile << centralnodes[i] << " ";

		} //end for
		
		myoutfile.close();	
	}
	else
	{
		system("CLS");
		std::cout << "Unable to make node centrality file:\n";
		std::cout << outfilename << "\n";
		std::system("PAUSE");
		system("CLS");
	}

	std::cout << "Statistics were successfully created for: " << infilename << "\n";

	

	delete [] mostneighbours;
	mostneighbours = 0;

	delete [] centralnodes;
	centralnodes = 0;

	delete [] weights2;
	weights2 = 0;

	delete [] x;
	x = 0;

	delete [] y;
	y = 0;

	delete [] z;
	z = 0;

}


/*
	transmission function:
		promps user to enter desired transmission range to be used when creating statistics.
		Intake as string then checks if all characters are numbers, then uses 'convertToDouble' function
		to set transmissionrange to desired number.
		returns -1 if user wishes to exit to main menu
*/
void transmission()
{
	
	std::string transmission = "";

	bool correct = true;

	system("CLS");

	do
	{

		correct = true;

		//Ask user for the tranmission range.

		std::cout << "\n";
		std::cout << "\t***********************************************\n";
		std::cout << "\t*                                             *\n";
		std::cout << "\t*             Static Statistics               *\n";
		std::cout << "\t*                                             *\n";
		std::cout << "\t*                                             *\n";
		std::cout << "\t*    Enter transmisson range of the network   *\n";
		std::cout << "\t*                                             *\n";
		std::cout << "\t*      Enter EXIT to exit to main menu        *\n";
		std::cout << "\t*                                             *\n";
		std::cout << "\t***********************************************\n";
		std::cout << "\n\n";

		std::cout << "\t                   >> "; getline(std::cin,transmission);
		
		exitmask = transmission; to_upper(exitmask);

		if (exitmask != "EXIT")
		{

			for (size_t i = 0; i < transmission.length() && correct == true;i++)
			{
				if (transmission[i] > '9' || transmission[i] < '0')
				{
					correct = false;
					std::system("CLS");
					std::cout << "Invalid input\n";
				}
			}

			if (correct == true)
			{
				transmissonrange = convertToDouble(transmission);
			}

		}
		else
		{
			transmissonrange = -1;
		}

	}while(correct == false);

	system("CLS");

}

